{+---------------------------------------------------------------------------+
 | COPYRIGHT: Copyright by yu wei, 2001 - 2002                              |
 | Unit Name:    KWizard                                                     |
 +---------------------------------------------------------------------------+
 | Author:        yu wei                                                     |
 | URL:           http://members.rogers.com/wyu66/index.htm                  |
 | Email:         william_yuwei@yahoo.com                                    |
 | Date:          December 30, 2001                                          |
 | Time:          15:59:46                                                   |
 | Last Updated:  Feburary 16, 2002                                          |
 | Purpose:       Wizard VCL component                                       |
 +---------------------------------------------------------------------------+
 | IMPORTANT: This is a freeware components, so you can use them any way.    |
 |            Please note that the component and software are provided       |
 |            "AS-IS" without warranty.                                      |
 +---------------------------------------------------------------------------+
 | LICENCE AGREEMENT                                                         |
 +---------------------------------------------------------------------------+
 |  THIS COMPONENT IS FREEWARE. IT IS FREE FOR COMMERICAL OR NON-COMMERICAL  |
 |  USE. BEFORE PROCEEDING WITH THE INSTALLATION AND/OR USE OF THIS          |
 |  COMPONENT, CAREFULLY READ THE FOLLOWING TERMS AND CONDITIONS OF THIS     |
 |  LICENSE AGREEMENT.                                                       |
 |                                                                           |
 |    BY INSTALLING OR USING THE COMPONENT YOU INDICATE YOUR ACCEPTANCE      |
 |    OF THIS AGREEMENT. IF YOU DO NOT ACCEPT OR AGREE WITH THESE TERMS,     |
 |    YOU MAY NOT INSTALL OR USE IT!                                         |
 |                                                                           |
 |    DISTRIBUTION RIGHTS:                                                   |
 |                                                                           |
 |    YOU ARE GRANTED A NON-EXCISIVE, ROYALTY-FREE RIGHT TO PRODUCE AND      |
 |    DISTRIBUTE COMPILED BINARY FILES (EXE, DLLs, ETC.) THAT ARE BUILT      |
 |    WITH THIS COMPONENT. YOU ARE FURTHER GRANTED PERMISSION TO             |
 |    REDISTRIBUTE ANY OF MY SOURCE CODES, PROVIDED THAT THE ORIGINAL        |
 |    ARCHIVE AS FOUND ON MY WEB SITE IS DISTRIBUTED UNMODIFIED. FOR         |
 |    EXAMPLE, IF YOU CREATE A DESCENDANT OF THIS COMPONENET YOU MUST        |
 |    INCLUDE IN THE ORIGINAL COMPONENT IN YOUR DISTRIBUTION PACKAGE.        |
 |                                                                           |
 |    RESTRICTIONS:                                                          |
 |                                                                           |
 |    WITHOUT THE EXPRESS WRITTEN CONSENT OF THE AUTHOR, YOU CANNOT:         |
 |                                                                           |
 |    DISTRIBUTE MODIFIED VERSIONS OF MY SOURCES CODES.  YOU MUST            |
 |    INCLUDE THE ORIGINAL ARCHIVE AS YOU FOUND IT AT MY WEB SITE.           |
 |    SELL OR LEASE ANY PORTION OF THIS SOURCE CODE.                         |
 |    YOU ARE, OF COURSE FREE TO SELL ANY OF YOUR OWN ORIGINAL CODE          |
 |    THAT WORKS WITH, ENHANCES WITH IT. DISTRIBUTE THIS SOURCE CODE         |
 |    FOR PROFIT.                                                            |
 |                                                                           |
 |    WARRANTY:                                                              |
 |                                                                           |
 |    THIS SOFTWARE IS PROVIDED "AS-IS" WITHOUT WARRANTY.                    |
 |    THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PRODUCT IS    |
 |    YOURS. SHOULD THE PRODUCT PROVE DEFECTIVE,  YOU ASSUME THE COST OF     |
 |    ALL NECESSARY SERVICING OR ERROR CORRECTION. THE AUTHOR DON'T WARRANT  |
 |    THAT THE FUNCTIONS CONTAINED IN COMPONENT WILL MEET YOUR REQUIREMENTS  |
 |    OR THAT OPERATION OF THE SOFTWARE WILL BE UNINTERRUPTED OR ERROR FREE. |
 |                                                                           |
 | SUGGESTIONS, COMMENTS AND BUGS:                                           |
 |                                                                           |
 |    Any suggestion, comment or bugs, please send to                        |
 |                                                                           |
 |      william_yuwei@yahoo.com                                              |
 |                                                                           |
 +---------------------------------------------------------------------------+
 | CONTRIBUTORS:                                                             |
 +---------------------------------------------------------------------------+
 |   Steve Forbes          <ozmosys@mira.net>                                |
 |   Chris Macksey         <c_macksey@hotmail.com>                           |
 |   Wayne Niddery         <waynen@logicfundamentals.com>                    |
 |   Raymond J. Schappe    <rschappe@isthmus-ts.com>                         |
 |   Theodore              <thpana@otenet.gr>                                |
 |   Max Evans             <max@codecraft.com.au>                            |
 +---------------------------------------------------------------------------+
 | HISTORY      COMMENTS                                                     |
 +---------------------------------------------------------------------------+
 | 02/18/2002   OnStartButtonClick, OnLastButtonClick, OnNextButtonClick,    |
 |              OnBackButtonClick, OnFinishButtonClick, OnCancelButtonClick, |
 |              is added for TKWizardCustomPage with a Stop parameter.       |
 |                                                                           |
 |              Note: these page click events is called before the wizard    |
 |                    button click events.                                   |
 |                                                                           |
 | 02/16/2002   Suggested by <Theodore>:                                     |
 |                1) ModalResult property is added for TKWizardButton        |
 |                2) Width property is added for TKWizardButton              |
 |                                                                           |
 | 02/12/2002   1) Suggested by <Max Evans>:                                 |
 |                  Having the next/finish buttons to be the default         |
 |                  button when a page shows.                                |
 |              2) Having the cancel button to be the default cancel button. |
 |                                                                           |
 | 02/11/2002   1) CanDisplay function is added for TKWizardRouteMapControl. |
 |              2) OnDisplaying event is added for TKWizardRouteMapControl,  |
 |                 so the route map can decide if it could display the page  |
 |                item or not.                                               |
 |                                                                           |
 | 02/10/2002   1) Introduce TKWizardImage class.                            |
 |              2) Clean up the code (TKWizardGraphicObject,                 |
 |                   TKWizardPageObject, ..., etc)                           |
 |              3) Now the TKWizardPageTitle is inherited from               |
 |                 TKWizardGraphicObject(known as TKWizardPersistent         |
 |                 in former).                                               |
 |              4) Suggested by <Tim Schneider>:                             |
 |                  Controls in the wizard page with aligned set to          |
 |                  something should be aligned properly without covering    |
 |                  the page header as well as the watermark. Hint:          |
 |                    overrided AdjustClientRect method is added for         |
 |                    both TKWizardCustomPage and TKWizardWelcomePage.       |
 |                                                                           |
 | 02/09/2002   1) Finish button can be displayed separatly.                 |
 |              2) Bug fixed: Changing the value of EnabledButtons property  |
 |                 of TKWizardCustomPage at run time doesn't refresh the     |
 |                 buttons' status on the screen.                            |
 |                                                                           |
 | 02/08/2002   Bug fixed: the OnEnterPage event is not triggled properly,   |
 |                they would be called at the time the wizard is loading     |
 |                them. 'not (csLoading in ComponentState)' added as the     |
 |                part of checking condition in SetActivePage method         |
 |                of TKWizard.                                               |
 |                                                                           |
 | 02/07/2002   VERSION 1.6 RELEASED                                         |
 |                                                                           |
 |              1) New property EnabledButtons and VisibleButtons added for  |
 |                 TKWizardCustomPage, so the developers can customize       |
 |                 buttons for each page at design time and run time.        |
 |              2) Remove Enabled and Visible properties from                |
 |                 TKWizardButton of TKWizard.                               |
 |                                                                           |
 | 02/06/2002   1) Bug fixed: change TKWizardWelcomePage's color from        |
 |                 clWindow to other colors or change                        |
 |                 TKWizardInteriorPage's color from other colors to         |
 |                 clWindow, the pages won't display in correct color.       |
 |                 Hint:                                                     |
 |                   By assigning default value of Color property in         |
 |                   published section of TKWizardCustomPage and             |
 |                   TKWizardWelcomePage class.                              |
 |              2) Suggested by <Steve Forbes>:                              |
 |                   ShowDivider added for TKWizardPageHeader to enable      |
 |                   or disable drawing the page header divider.             |
 |              3) Use Object.Free instead of FreeAndNil,                    |
 |                 Rectangle(ARect.Left, ...) instead of Rectangle(ARect),   |
 |                 so we can support Delphi 4.                               |
 |                                                                           |
 | 02/05/2002   1) Added by <Theodore>:                                      |
 |                  ButtonHelp added for TKWizard.                           |
 |              2) RepositionButtons method of TKWizard is improved.         |
 |                                                                           |
 | 02/04/2002   function IsForward added, return true if FromPage is         |
 |              forward to ToPage, return false if FromPage is backward      |
 |              to ToPage.                                                   |
 |                                                                           |
 | 02/03/2002   1) Bug fixed by <Theodore>: SelectPriorPage calls            |
 |                   OnSelectFirstPage event rather the OnSelectPriorPage.               |
 |              2) Suggested by <Theodore>:                                  |
 |                   FromPage parameters added for OnEnterPage event,        |
 |                   so the developers can detect from where it enters.      |
 |              3) Suggested by <Theodore>:                                  |
 |                   ToPage paramters added for OnExitPage event, so the     |
 |                   developers can detect to where it exits.                |
 |              4) Suggested by <Theodore>:                                  |
 |                   OnExitPage event now is called just BEFORE (not after)  |
 |                   the page is hidden and BEFORE the new page is actived.  |
 |                   It provides the last chance to the developers to stop   |
 |                   changing to the new page by raising a message.          |
 |                                                                           |
 | 02/02/2002   VERSION 1.5 RELEASED                                         |
 |                                                                           |
 |              1) DoAddPage, DoDeletePage, DoUpdatePage, DoMovePage added   |
 |                 for TKWizardRouteMapControl                               |
 |              2) Overrided SetParent added for TKWizardRouteMapControl     |
 |                   to detect if the parent is TKWizard or its descentants. |
 | 01/31/2002   1) Improved the RepositionButtons method of TKWizard,        |
 |                 so all the buttons can be positioned properly regardless  |
 |                 how their neighbors are.                                  |
 |              2) CM_VisibleChanged message handler added for               |
 |                 TKWizardButtonControl, so when the button is visible or   |
 |                 invisible, it can make the rest buttons in proper         |
 |                 position.                                                 |
 |                                                                           |
 | 01/30/2002   1) Rename the methods of TKWizardRouteMapControl             |
 |              2) WizardPageMoved method added for TKWizardRouteMapControl  |
 |                 which fired after the order of the page changed.          |
 |              3) OnPaintPage event added for TKWizardCustomPage, so        |
 |                 the developers can custom draw the page.                  |
 |              4) A TKWizardCustomPage parameter added for IsFirstPage,     |
 |                 IsLastPage of TKWizard to test if the specific page is    |
 |                 the first page or the last page.                          |
 |              5) Buttons property added for TKWizardCustomPage, it can     |
 |                 easily access all navigation buttons of TKWizard.         |
 |              6) Improved the process to handle the button visible         |
 |                 property in more efficent way.                            |
 |                   see UpdateButtonsStatus method of TKWizard              |
 |                                                                           |
 | 01/29/2002   1) Pages property added for TKWizard.                        |
 |              2) PageCount property added for TKWizard.                    |
 |              3) Page List Property Editor added for Pages property        |
 |                of TKWizard. From this property editor, we can             |
 |                                                                           |
 |                  a) Add new wizard pages.                                 |
 |                  b) Remove selected pages.                                |
 |                  c) Drag drop selected page item to change pages' order.  |
 |                                                                           |
 | 01/28/2002   1) Bug fixed: if the current active page set to disabled,    |
 |                            the wizard would not go to next page.          |
 |              2) Page screen flicker problem solved by setting             |
 |                 the DoubleBuffered property of TKWizardCustomPage         |
 |                 to True.                                                  |
 |              3) ParentFont property added for TKWizardPageHeader.         |
 |                                                                           |
 | 01/27/2002   VERSION 1.5 BETA RELEASED                                    |
 |                                                                           |
 |              1) KWizard About form added by <Steve Forbes>                |
 |                   Thanks for his great job !!!!                           |
 |              2) Improve the design time button function, press Back       |
 |                 button at first page will forward to the last page.       |
 |                 While press Next button at last page will forward to      |
 |                 the first page. (See FindNextPage method in TKWizard)     |
 |              3) Fixed AV when delete only one page in the wizard at       |
 |                 design time. (see RemovePage method in TKWizard)          |
 |              4) NumGlyphs property added for TKWizardNavigateButton by    |
 |                 <Steve Forbes>, to solve the problem where the            |
 |                 NumGlyphs property of the actual button always reset      |
 |                 to 1 when it is created dynamically.                      |
 |              5) Layout property added for TKWizardNavigateButton.         |
 |              6) Set ImageAlign property's default value of                |
 |                 TKWizardPageHeader to waRight.                            |
 |                                                                           |
 | 01/26/2002   1) Suggested by <Steve Forbes>:                              |
 |                   Anchors, AnchorPlacement, Indent property added for     |
 |                   the text in TKWizardPageTitle. Remove Left, Top,        |
 |                   Width, Height properties from TKWizardPageTitle. so     |
 |                   it is much easiler to operate the title and subtitle.   |
 |              2) Image property added for TKWizardCustomPage,              |
 |                 both Welcome page and Interior page can display a         |
 |                 background image.                                         |
 |              3) Image property added for the TKWizardWaterMark.           |
 |              4) ImageIndex, ImageAlign, ImageOffset property added for    |
 |                 TKWizardPageHeader. the PageHeader use ImageIndex         |
 |                 to retreive image from the header image list of           |
 |                 TKWizard.                                                 |
 |                                                                           |
 | 01/25/2002   VERSION 1.2 RELEASED                                         |
 |                                                                           |
 |                Finally, KWizard has its offical icon!!! It is very cool!  |
 |                Thanks <Steve Forbes> for his great job !!!!               |
 |                                                                           |
 |              1) Move OnEnterPage, OnPage, OnExitPage event from TKWizard  |
 |                 into TKWizardCustomPage.                                  |
 |              2) TKWizardPagePanel added, suggested by <Steve Forbes>.     |
 |              3) Glyph property added for TKWizardNavigateButton.          |
 |              4) HeaderImages property added for TKWizard, it is an        |
 |                 image list, which stores all the page header images.      |
 |                                                                           |
 | 01/24/2002   1) Rename TKWizardTitle to TKWizardPageTitle.                |
 |              2) PaintTo method added for TKWizardWaterMark.               |
 |                 PaintTo method added for TKWizardPageHeader.              |
 |                 PainTo method added for TKWizardPageTitle.                |
 |              3) Remove the DisplayPageHeader method from                  |
 |                 TKWizardCustomPage.                                       |
 |              4) OnPage event added for TKWizard, fired after the page     |
 |                 shows up.                                                 |
 |              5) Pages, PageCount, PageIndex property, and default code    |
 |                 added for all virtual method for TKWizardRouteMapControl. |
 |              6) Compiler directive added, suggested                       |
 |                 by <Raymond J. Schappe>.                                  |
 |              7) Handle Design time package and Run time package,          |
 |                 package file name convenstion suggested by                |
 |                 <Steve Forbes>:                                           |
 |                   Design time package: KWizardD?.dpk (bpl, dcp, ...)      |
 |                   Run time package: KWizardD?R.dbp (bpl, dcp, ...)        |
 |                   here the ? = Delphi Version (5, 6, ..., etc)            |
 |                                                                           |
 | 01/23/2002   1) Start Page, Last Page buttons added for TKWizard,         |
 |                 default they are invisible.                               |
 |              2) Visible property added for TKWizardNavigateButton.        |
 |                                                                           |
 | 01/22/2002   BorderWidth property added for TKWizardWaterMark, suggested  |
 |              by <Steve Forbes>                                            |
 |                                                                           |
 |              1) Remove the TKWizardButtonBar, now all the navigate        |
 |                 buttons are located in the Wizard. Hint:                  |
 |                   Add overrided AdjustClientRect for TKWizard.            |
 |              2) Bug fixed: Add csAcceptsControls control style into       |
 |                   TKWizard, otherwise it won't accept other controls      |
 |                   like KWizardRouteMap.                                   |
 |              3) Bug fixed: TKWizard.GetChildren procedure, it won't       |
 |                   display another controls (include KWizardRouteMap       |
 |                   Control) even if the control is in the wizard.          |
 |              4) Align property added for TKWizardRouteMap, so the         |
 |                 KWizardRouteMap can display at either left or right       |
 |                 side of the Wizard.                                       |
 |              5) Align property added for TKWaterMark, so it can be        |
 |                 displayed at either left or right side of Welcome Page.   |
 |                                                                           |
 | 01/21/2002   VERSION 1.1 RELEASED                                         |
 |                                                                           |
 |              Suggested by <Chris Macksey>:                                |
 |                                                                           |
 |              1) Add OnSelectNextPage, OnSelectPriorPage,                  |
 |                 OnSelectFirstPage, OnSelectLastPage events, so user can   |
 |                 redirect the page try to go to.                           |
 |              2) Add OnEnterPage, triggled before the page shows up.       |
 |                 Add OnExitPage, triggled after the page is hidded.        |
 |                                                                           |
 | 01/14/2002   1) Add ShowRouteMap property for the TKWizard.               |
 |              2) Add destructor in the TKWizardRouteMap class to fix       |
 |                 AV when browse pages after destroy the TKWizardRouteMap   |
 |                 component.                                                |
 |                                                                           |
 | 01/13/2002   Make the TKWizardRouteMap as a separat new component         |
 |              so the user can design its own routemap and communicate      |
 |              with TKWizard smoothly.                                      |
 |                                                                           |
 | 01/12/2002   VERSION 1.0 RELEASED                                         |
 |                                                                           |
 |              1) Fixed by <Wayne Niddery> :                                |
 |                   Under certain circumstance, the Wizard did not always   |
 |                   default to the first page. Add overrided                |
 |                   Loaded method in the TKWizard class.                    |
 |              2) Restructure: add TKWizardHeader and TKWizardWaterMark,    |
 |                 I hate to list all properites like: HeaderColor,          |
 |                 HeaderWidth, HeaderVisible, ... etc. Instead, I group     |
 |                 them together into particular class, and it can make      |
 |                 the whole component has a very clean property             |
 |                 structure.                                                |
 |                                                                           |
 | 01/11/2002   1) Add word break feature when display title and subtitle.   |
 |              2) At Design time, display page name in the wizard page.     |
 |              3) Let the TWizardCustomPage paint and fill its area first   |
 |                 and let TWizardWelcomePage and TWizardInteriorPage        |
 |                 do the rest.                                              |
 |                                                                           |
 | 01/10/2002   BETA VERSION RELEASED                                        |
 |                                                                           |
 |              1) Delete BackButton, NextButton, FinishButton,              |
 |                 CancelButton property, instead of a Button array.         |
 |              2) Introduce TKWizardBackButton, TKWizardNextButton,         |
 |                 TKWizardFinishButton and TKWizardCancelButton Control     |
 |              3) Add TKWizardTitle class, HeaderColor, HeaderHeight,       |
 |                 HeaderVisible property for TKWizardCustomPage.            |
 |              4) Add WaterMarkColor, WaterMarkWidth, WaterMarkVisible      |
 |                 property for TKWizardWelcomePage.                         |
 |              5) Paint method of TKWizardWelcomPage improved,              |
 |                 TKWizardInteriorPage, so they can display header          |
 |                 as well as title and subtitle.                            |
 |                                                                           |
 | 01/06/2002   1) Add TKWizardRouteMap, Improve all existing functions      |
 |                 and class.                                                |
 |              2) Add TKWizardCustomPage.                                   |
 |                                                                           |
 | 01/05/2002   1) Add TKWizardNavigateButton class.                         |
 |              2) Add BackButton, NextButton, FinishButton,                 |
 |                 CancelButton property for TKWizard.                       |
 |                                                                           |
 | 01/04/2002   1) Add ShowDivider property for TKWizard.                    |
 |              2) Add GetButtonClick, SetButtonClick for TKWizardButtonBar. |
 |              3) Draw divider in fsGroove frame style.                     |
 |                                                                           |
 | 12/30/2001   Initial create.                                              |
 +---------------------------------------------------------------------------+
 | TODO LIST                                                                 |
 +---------------------------------------------------------------------------+
 | Wizard page can be transparent                                            |
 +---------------------------------------------------------------------------+}

unit KWizard;

interface

{$I KOMPONENTS.INC}

uses Windows, {$IFDEF DELPHI6}Types,{$ENDIF} Classes, Messages, SysUtils,
     Controls, Forms, Graphics, Buttons, ImgList, KCommon;

type
  TKWizardAboutInfo = (KWizardAbout);  // Added by <Steve Forbes>
  TKWizardAlign = alTop..alRight;
  TKWizardLeftRight = alLeft..alRight;
  TKWizardButtonKind = (bkStart, bkLast, bkBack, bkNext, bkFinish, bkCancel,
    bkHelp);
  TKWizardButtonSet = set of TKWizardButtonKind;

const
  bkAllButtons = [bkStart, bkLast, bkBack, bkFinish, bkNext, bkCancel, bkHelp];

type
  TKWizardCustomPage = class;
  TKWizard = class;

  TKWizardButtonControl = class(TBitBtn)
  private
    FWizard: TKWizard;
    FAlignment: TKWizardLeftRight;
    procedure CMVisibleChanged(var Msg: TMessage); message CM_VISIBLECHANGED;
    procedure CMDesignHitTest(var Msg: TCMDesignHitTest); message CM_DESIGNHITTEST;
  protected
    property Wizard: TKWizard read FWizard write FWizard;
    property Alignment: TKWizardLeftRight read FAlignment write FAlignment;
  public
    constructor Create(AOwner: TComponent); override;
  end;

  TKWizardButtonControlClass = class of TKWizardButtonControl;

  { YW - The wrapper of the TKWizardButtonControl }
  TKWizardNavigateButton = class(TPersistent)
  private
    FControl: TKWizardButtonControl;
    procedure SetCaption(const Value: string);
    function GetCaption: string;
    function GetGlyph: TBitmap;
    procedure SetGlyph(const Value: TBitmap);
    function GetNumGlyphs: Integer;
    procedure SetNumGlyphs(const Value: Integer);
    function GetLayout: TButtonLayout;
    procedure SetLayout(const Value: TButtonLayout);
    function GetModalResult: TModalResult;
    procedure SetModalResult(const Value: TModalResult);
    function GetButtonWidth: Integer;
    procedure SetButtonWidth(const Value: Integer);
  protected
    property Control: TKWizardButtonControl
      read FControl write FControl;
  published
    property Glyph: TBitmap read GetGlyph write SetGlyph;
    property Caption: string read GetCaption write SetCaption;
    property NumGlyphs: Integer read GetNumGlyphs write SetNumGlyphs;
    property Layout: TButtonLayout read GetLayout write SetLayout;
    property ModalResult: TModalResult read GetModalResult write SetModalResult;
    property Width: Integer read GetButtonWidth write SetButtonWidth;
  end;

  TKWizardRouteMapDisplayEvent = procedure(Sender: TObject;
    const Page: TKWizardCustomPage; var AllowDisplay: Boolean) of object;

  { YW - TKWizardRouteMap base class }
  TKWizardRouteMapControl = class(TCustomControl)
  private
    FWizard: TKWizard;
    FAlign: TKWizardAlign;
    FPages: TList;
    FPageIndex: Integer;
    FOnDisplaying: TKWizardRouteMapDisplayEvent;
    function GetPage(Index: Integer): TKWizardCustomPage;
    function GetPageCount: Integer;
    procedure SetAlign(Value: TKWizardAlign);
    procedure SetPageIndex(Value: Integer);
    procedure CMDesignHitTest(var Msg: TCMDesignHitTest); message CM_DESIGNHITTEST;
    procedure DoAddPage(const APage: TKWizardCustomPage);
    procedure DoDeletePage(const APage: TKWizardCustomPage);
    procedure DoUpdatePage(const APage: TKWizardCustomPage);
    procedure DoActivatePage(const APage: TKWizardCustomPage);
    procedure DoMovePage(const APage: TKWizardCustomPage; const OldIndex: Integer);
  protected
    procedure SetParent(AParent: TWinControl); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    function PageAtPos(Pt: TPoint): TKWizardCustomPage; virtual;
    procedure WizardPageAdded(const APage: TKWizardCustomPage); virtual;
    procedure WizardPageDeleted(const APage: TKWizardCustomPage); virtual;
    procedure WizardPageUpdated(const APage: TKWizardCustomPage); virtual;
    procedure WizardPageActivated(const APage: TKWizardCustomPage); virtual;
    procedure WizardPageMoved(const APage: TKWizardCustomPage;
      const OldIndex: Integer); virtual;
    function CanDisplay(const APage: TKWizardCustomPage): Boolean; virtual;
    property Wizard: TKWizard read FWizard write FWizard;
    property Align: TKWizardAlign read FAlign write SetAlign default alLeft;
    property OnDisplaying: TKWizardRouteMapDisplayEvent
      read FOnDisplaying write FOnDisplaying;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Pages[Index: Integer]: TKWizardCustomPage read GetPage;
    property PageCount: Integer read GetPageCount;
    property PageIndex: Integer read FPageIndex write SetPageIndex;
  end;

  TKWizardImage = class(TPersistent)
  private
    FPicture: TPicture;
    FAlignment: TKImageAlignment;
    FLayout: TKImageLayout;
    FOnChange: TNotifyEvent;
    procedure SetPicture(Value: TPicture);
    procedure SetAlignment(Value: TKImageAlignment);
    procedure SetLayout(Value: TKImageLayout);
    function GetTransparent: Boolean;
    procedure SetTransparent(Value: Boolean);
    procedure SetOnChange(Value: TNotifyEvent);
    procedure DoChange;
  protected
    procedure PaintTo(const ACanvas: TCanvas; ARect: TRect);
  public
    constructor Create;
    destructor Destroy; override;
    property OnChange: TNotifyEvent read FOnChange write SetOnChange;
  published
    property Picture: TPicture read FPicture write SetPicture;
    property Alignment: TKImageAlignment read FAlignment write SetAlignment;
    property Layout: TKImageLayout read FLayout write SetLayout;
    property Transparent: Boolean read GetTransparent write SetTransparent;
  end;

  TKWizardGraphicObject = class(TPersistent)
  private
    FColor: TColor;
    FVisible: Boolean;
    procedure SetColor(Value: TColor);
    procedure SetVisible(Value: Boolean);
  protected
    procedure VisibleChanged; virtual;
    procedure ColorChanged; virtual;
    procedure DoChange; virtual; abstract;
  public
    constructor Create; virtual;
    procedure PaintTo(ACanvas: TCanvas; var ARect: TRect); virtual; abstract;
  published
    property Color: TColor read FColor write SetColor;
    property Visible: Boolean read FVisible write SetVisible;
  end;

  TKWizardPageHeader = class;

  { YW - Wizard Page Title class }
  TKWizardPageTitle = class(TKWizardGraphicObject)
  private
    FWizardPageHeader: TKWizardPageHeader;
    FText: string;
    FAlignment: TAlignment;
    FAnchorPlacement: Integer;
    FAnchors: TAnchors;
    FIndent: Integer;
    FFont: TFont;
    procedure SetText(Value: string);
    procedure SetAlignment(Value: TAlignment);
    procedure SetAnchors(Value: TAnchors);
    procedure SetAnchorPlacement(Value: Integer);
    procedure SetIndent(Value: Integer);
    procedure SetFont(Value: TFont);
    procedure SetWizardPageHeader(Value: TKWizardPageHeader);
    procedure OnChange(Sender: TObject);
    procedure AdjustFont(const AFont: TFont);
  protected
    { YW - Get the area where the title text should be painted on. }
    function GetTextRect(const ACanvas: TCanvas;
      const ARect: TRect): TRect; virtual;
    procedure DoChange; override;
    property WizardPageHeader: TKWizardPageHeader
      read FWizardPageHeader write SetWizardPageHeader;
  public
    constructor Create; override;
    destructor Destroy; override;
    procedure PaintTo(ACanvas: TCanvas; var ARect: TRect); override;
  published
    property Text: string read FText write SetText;
    property Anchors: TAnchors read FAnchors write SetAnchors;
    property AnchorPlacement: Integer
      read FAnchorPlacement write SetAnchorPlacement;
    property Indent: Integer read FIndent write SetIndent;
    property Alignment: TAlignment read FAlignment write SetAlignment;
    property Font: TFont read FFont write SetFont;
  end;

  TKWizardPageObject = class(TKWizardGraphicObject)
  private
    FWizardPage: TKWizardCustomPage;
    procedure SetWizardPage(Value: TKWizardCustomPage);
  protected
    procedure Initialize; virtual;
    procedure DoChange; override;
    property WizardPage: TKWizardCustomPage read FWizardPage write SetWizardPage;
  end;

  { YW - Wizard Page Header class }
  TKWizardPageHeader = class(TKWizardPageObject)
  private
    FHeight: Integer;
    FParentFont: Boolean;
    FTitle: TKWizardPageTitle;
    FSubtitle: TKWizardPageTitle;
    FImageIndex: Integer;
    FImageOffset: Integer;
    FImageAlignment: TKImageLeftRight;
    FShowDivider: Boolean;
    procedure SetHeight(Value: Integer);
    procedure SetImageIndex(Value: Integer);
    procedure SetImageOffset(Value: Integer);
    procedure SetImageAlignment(Value: TKImageLeftRight);
    procedure SetParentFont(Value: Boolean);
    procedure SetShowDivider(Value: Boolean);
    procedure AdjustTitleFont;
  protected
    procedure VisibleChanged; override;
    procedure Initialize; override;
    { YW - the return value of ARect is the area where the title should be
       painted on. The result of GetImageRect is the image area. }
    function GetImageRect(const AImages: TCustomImageList;
      var ARect: TRect): TRect; virtual;
  public
    constructor Create; override;
    destructor Destroy; override;
    procedure PaintTo(ACanvas: TCanvas; var ARect: TRect); override;
  published
    property ImageIndex: Integer read FImageIndex write SetImageIndex;
    property ImageOffset: Integer read FImageOffset write SetImageOffset;
    property ImageAlignment: TKImageLeftRight
      read FImageAlignment write SetImageAlignment;
    property Height: Integer read FHeight write SetHeight;
    property ParentFont: Boolean read FParentFont write SetParentFont;
    property Title: TKWizardPageTitle read FTitle write FTitle;
    property Subtitle: TKWizardPageTitle read FSubtitle write FSubtitle;
    property ShowDivider: Boolean read FShowDivider write SetShowDivider;
    property Color;
    property Visible;
  end;

  { YW - Welcome Page's watermark class }
  TKWizardWaterMark = class(TKWizardPageObject)
  private
    FAlign: TKWizardLeftRight;
    FWidth: Integer;
    FBorderWidth: Integer;
    FImage: TKWizardImage;
    procedure SetWidth(Value: Integer);
    procedure SetBorderWidth(Value: Integer);
    procedure SetAlign(Value: TKWizardLeftRight);
    procedure ImageChanged(Sender: TObject);
  protected
    procedure VisibleChanged; override;
  public
    constructor Create; override;
    destructor Destroy; override;
    procedure PaintTo(ACanvas: TCanvas; var ARect: TRect); override;
  published
    property Align: TKWizardLeftRight read FAlign write SetAlign;
    property BorderWidth: Integer read FBorderWidth write SetBorderWidth;
    property Image: TKWizardImage read FImage write FImage;
    property Width: Integer read FWidth write SetWidth;
    property Color;
    property Visible;
  end;

  { YW - Wizard Page Panel class used by Wizard Custom Page }
  TKWizardPagePanel = class(TKWizardPageObject)
  private
    FBorderWidth: Word;
    procedure SetBorderWidth(Value: Word);
  public
    constructor Create; override;
    procedure PaintTo(ACanvas: TCanvas; var ARect: TRect); override;
  published
    property BorderWidth: Word read FBorderWidth write SetBorderWidth;
    property Color;
    property Visible;
  end;

  TKWizardPageClickEvent = procedure(Sender: TObject; var Stop: Boolean) of object;
  TKWizardPaintPageEvent = procedure(Sender: TObject; ACanvas: TCanvas;
    var ARect: TRect) of object;
  TKWizardChangePageEvent = procedure(Sender: TObject;
    const Page: TKWizardCustomPage) of object;

  { YW - Wizard Custom Page }
  TKWizardCustomPage = class(TCustomControl)
  private
    FWizard: TKWizard;
    FHeader: TKWizardPageHeader;
    FPanel: TKWizardPagePanel;
    FImage: TKWizardImage;
    FEnabledButtons: TKWizardButtonSet;
    FVisibleButtons: TKWizardButtonSet;
    FDrawing: Boolean;
    FOnPaintPage: TKWizardPaintPageEvent;
    FOnEnterPage: TKWizardChangePageEvent;
    FOnPage: TNotifyEvent;
    FOnExitPage: TKWizardChangePageEvent;
    FOnStartButtonClick: TKWizardPageClickEvent;
    FOnLastButtonClick: TKWizardPageClickEvent;
    FOnNextButtonClick: TKWizardPageClickEvent;
    FOnBackButtonClick: TKWizardPageClickEvent;
    FOnCancelButtonClick: TKWizardPageClickEvent;
    FOnFinishButtonClick: TKWizardPageClickEvent;
    function GetPageIndex: Integer;
    procedure SetPageIndex(const Value: Integer);
    procedure SetWizard(AWizard: TKWizard);
    procedure SetEnabledButtons(Value: TKWizardButtonSet);
    procedure SetVisibleButtons(Value: TKWizardButtonSet);
    procedure ImageChanged(Sender: TObject);
    procedure WMEraseBkgnd(var Message: TWmEraseBkgnd); message WM_ERASEBKGND;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
    procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure ReadState(Reader: TReader); override;
    procedure AdjustClientRect(var Rect: TRect); override;
    procedure Paint; override;
    { YW - DrawPage is called by paint method. all the derived page controls
       should call this method to paint itsself rather than the overrided
       paint method. }
    procedure DrawPage(ACanvas: TCanvas; var ARect: TRect); virtual;
    { YW - called before the page shows up. Page: From page }
    procedure Enter(const FromPage: TKWizardCustomPage); virtual;
    { YW - called after the page shows up. }
    procedure Done; virtual;
    { YW - called just before the page is hidden. Page: To page }
    procedure Exit(const ToPage: TKWizardCustomPage); virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Wizard: TKWizard read FWizard write SetWizard;
    property PageIndex: Integer
      read GetPageIndex write SetPageIndex stored False;
  published
    property Header: TKWizardPageHeader read FHeader write FHeader;
    property Image: TKWizardImage read FImage write FImage;
    property Panel: TKWizardPagePanel read FPanel write FPanel;
    property EnabledButtons: TKWizardButtonSet
      read FEnabledButtons write SetEnabledButtons default bkAllButtons;
    property VisibleButtons: TKWizardButtonSet
      read FVisibleButtons write SetVisibleButtons
      default [bkBack, bkNext, bkCancel];
    property Color default clBtnFace;
    property Caption;
    property Enabled;
    property Font;
    property Left stored False;
    property Height stored False;
    property PopupMenu;
    property ShowHint;
    property Top stored False;
    property Width stored False;
    property OnEnterPage: TKWizardChangePageEvent
      read FOnEnterPage write FOnEnterPage;
    property OnPage: TNotifyEvent read FOnPage write FOnPage;
    property OnExitPage: TKWizardChangePageEvent
      read FOnExitPage write FOnExitPage;
    property OnPaintPage: TKWizardPaintPageEvent
      read FOnPaintPage write FOnPaintPage;
    property OnStartButtonClick: TKWizardPageClickEvent
      read FOnStartButtonClick write FOnStartButtonClick;
    property OnLastButtonClick: TKWizardPageClickEvent
      read FOnLastButtonClick write FOnLastButtonClick;
    property OnNextButtonClick: TKWizardPageClickEvent
      read FOnNextButtonClick write FOnNextButtonClick;
    property OnBackButtonClick: TKWizardPageClickEvent
      read FOnBackButtonClick write FOnBackButtonClick;
    property OnCancelButtonClick: TKWizardPageClickEvent
      read FOnCancelButtonClick write FOnCancelButtonClick;
    property OnFinishButtonClick: TKWizardPageClickEvent
      read FOnFinishButtonClick write FOnFinishButtonClick;
  end;

  { YW - Wizard Welcome Page }
  TKWizardWelcomePage = class(TKWizardCustomPage)
  private
    FWaterMark: TKWizardWaterMark;
  protected
    procedure AdjustClientRect(var Rect: TRect); override;
    procedure DrawPage(ACanvas: TCanvas; var ARect: TRect); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Color default clWindow;
    property WaterMark: TKWizardWaterMark read FWaterMark write FWaterMark;
  end;

  { YW - Wizard Interior Page }
  TKWizardInteriorPage = class(TKWizardCustomPage)
  protected
    procedure DrawPage(ACanvas: TCanvas; var ARect: TRect); override;
  end;

  TKWizardSelectPageEvent = procedure(Sender: TObject;
    FromPage: TKWizardCustomPage; var ToPage: TKWizardCustomPage) of object;

  { YW - KWizard Page List }
  TKWizardPageList = class(TList)
  private
    FWizard: TKWizard;
  protected
    procedure Notify(Ptr: Pointer; Action: TListNotification); override;
    property Wizard: TKWizard read FWizard write FWizard;
  public
    destructor Destroy; override;
  end;

  { YW - KWizard Control }
  TKWizard = class(TCustomControl)
  private
    FPages: TKWizardPageList;
    FActivePage: TKWizardCustomPage;
    FRouteMap: TKWizardRouteMapControl;
    FNavigateButtons: array[TKWizardButtonKind] of TKWizardNavigateButton;
    FButtonBarHeight: Integer;
    FShowDivider: Boolean;
    FOnSelectNextPage: TKWizardSelectPageEvent;
    FOnSelectPriorPage: TKWizardSelectPageEvent;
    FOnSelectFirstPage: TKWizardSelectPageEvent;
    FOnSelectLastPage: TKWizardSelectPageEvent;
    FHeaderImages: TCustomImageList;
    FImageChangeLink: TChangeLink;
    FAboutInfo: TKWizardAboutInfo;  // Add by Steve Forbes
    procedure SetShowDivider(Value: Boolean);
    function GetShowRouteMap: Boolean;
    procedure SetShowRouteMap(Value: Boolean);
    procedure SetButtonBarHeight(Value: Integer);
    procedure SetActivePage(Page: TKWizardCustomPage);
    procedure SetHeaderImages(Value: TCustomImageList);
    function GetButtonClick(const Index: TKWizardButtonKind): TNotifyEvent;
    procedure SetButtonClick(const Index: TKWizardButtonKind;
      const Value: TNotifyEvent);
    procedure ImageListChange(Sender: TObject);
    procedure CreateNavigateButtons;
    procedure ChangeActivePage(Page: TKWizardCustomPage);
    function GetActivePageIndex: Integer;
    procedure SetActivePageIndex(Value: Integer);
    function GetPageCount: Integer;
    procedure RepositionButtons;
    procedure UpdateButtonsStatus;
    procedure WMEraseBkgnd(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
    procedure CMDesignHitTest(var Message: TCMDesignHitTest); message CM_DESIGNHITTEST;
  protected
    procedure Loaded; override;
    procedure AdjustClientRect(var Rect: TRect); override;
    procedure GetChildren(Proc: TGetChildProc; Root: TComponent); override;
    procedure ShowControl(AControl: TControl); override;
    procedure Paint; override;
    procedure Resize; override;
    procedure InsertPage(Page: TKWizardCustomPage);
    procedure RemovePage(Page: TKWizardCustomPage);
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    function GetButtonControlClass(
      AKind: TKWizardButtonKind): TKWizardButtonControlClass; virtual;
    property ButtonBarHeight: Integer
      read FButtonBarHeight write SetButtonBarHeight;
  public
    constructor Create(AComponent: TComponent); override;
    destructor Destroy; override;
    procedure SelectPriorPage;
    procedure SelectNextPage;
    procedure SelectFirstPage;
    procedure SelectLastPage;
    function IsFirstPage(const APage: TKWizardCustomPage;
      CheckDisable: Boolean = True): Boolean;
    function IsLastPage(const APage: TKWizardCustomPage;
      CheckDisable: Boolean = True): Boolean;
    function FindNextPage(PageIndex: Integer; const Step: Integer = 1;
      CheckDisable: Boolean = True): TKWizardCustomPage;
    function IsForward(const FromPage, ToPage: TKWizardCustomPage): Boolean;
    property ActivePageIndex: Integer
      read GetActivePageIndex write SetActivePageIndex;
    property PageCount: Integer read GetPageCount;
  published
    property Pages: TKWizardPageList read FPages;
    property About: TKWizardAboutInfo    // Add by Steve Forbes
      read FAboutInfo write FAboutInfo stored False;
    property ActivePage: TKWizardCustomPage
      read FActivePage write SetActivePage;
    property ButtonStart: TKWizardNavigateButton
      read FNavigateButtons[bkStart] write FNavigateButtons[bkStart];
    property ButtonLast: TKWizardNavigateButton
      read FNavigateButtons[bkLast] write FNavigateButtons[bkLast];
    property ButtonBack: TKWizardNavigateButton
      read FNavigateButtons[bkBack] write FNavigateButtons[bkBack];
    property ButtonNext: TKWizardNavigateButton
      read FNavigateButtons[bkNext] write FNavigateButtons[bkNext];
    property ButtonFinish: TKWizardNavigateButton
      read FNavigateButtons[bkFinish] write FNavigateButtons[bkFinish];
    property ButtonCancel: TKWizardNavigateButton
      read FNavigateButtons[bkCancel] write FNavigateButtons[bkCancel];
    property ButtonHelp: TKWizardNavigateButton
      read FNavigateButtons[bkHelp] write FNavigateButtons[bkHelp];
    property ShowDivider: Boolean
      read FShowDivider write SetShowDivider default True;
    property ShowRouteMap: Boolean
      read GetShowRouteMap write SetShowRouteMap;
    property HeaderImages: TCustomImageList
      read FHeaderImages write SetHeaderImages;
    property OnSelectFirstPage: TKWizardSelectPageEvent
      read FOnSelectFirstPage write FOnSelectFirstPage;
    property OnSelectLastPage: TKWizardSelectPageEvent
      read FOnSelectLastPage write FOnSelectLastPage;
    property OnSelectNextPage: TKWizardSelectPageEvent
      read FOnSelectNextPage write FOnSelectNextPage;
    property OnSelectPriorPage: TKWizardSelectPageEvent
      read FOnSelectPriorPage write FOnSelectPriorPage;
    property OnStartButtonClick: TNotifyEvent index bkStart
      read GetButtonClick write SetButtonClick;
    property OnLastButtonClick: TNotifyEvent index bkLast
      read GetButtonClick write SetButtonClick;
    property OnBackButtonClick: TNotifyEvent index bkBack
      read GetButtonClick write SetButtonClick;
    property OnNextButtonClick: TNotifyEvent index bkNext
      read GetButtonClick write SetButtonClick;
    property OnFinishButtonClick: TNotifyEvent index bkFinish
      read GetButtonClick write SetButtonClick;
    property OnCancelButtonClick: TNotifyEvent index bkCancel
      read GetButtonClick write SetButtonClick;
    property Color;
    property Font;
    property Enabled;
    property Visible;
  end;

implementation

const

  ciButtonWidth = 75;
  ciButtonHeight = 25;
  ciButtonBarHeight = 42;
  ciButtonPlacement = (ciButtonBarHeight - ciButtonHeight) div 2;

resourcestring

  rsFirstButtonCaption = 'To &Start Page';
  rsLastButtonCaption = 'To &Last Page';
  rsBackButtonCaption = '< &Back';
  rsNextButtonCaption = '&Next >';
  rsCancelButtonCaption = 'Cancel';
  rsFinishButtonCaption = '&Finish';
  rsHelpButtonCaption = '&Help';
  rsWelcome = 'Welcome';
  rsTitle = 'Title';
  rsSubtitle = 'Subtitle';
  rsInvalidParentControl = 'The Parent should be TKWizard or its descendants.';
  rsInvalidWizardPage = 'Pages are belong to different wizard.';

type
  EKWizard = class(Exception);

  { YW - First Button }
  TKWizardStartButton = class(TKWizardButtonControl)
  public
    constructor Create(AOwner: TComponent); override;
    procedure Click; override;
  end;

  { YW - Last Button }
  TKWizardLastButton = class(TKWizardButtonControl)
  public
    constructor Create(AOwner: TComponent); override;
    procedure Click; override;
  end;

  { YW - Back Button }
  TKWizardBackButton = class(TKWizardButtonControl)
  public
    constructor Create(AOwner: TComponent); override;
    procedure Click; override;
  end;

  { YW - Next Button }
  TKWizardNextButton = class(TKWizardButtonControl)
  public
    constructor Create(AOwner: TComponent); override;
    procedure Click; override;
  end;

  { YW - Finish Button }
  TKWizardFinishButton = class(TKWizardButtonControl)
  public
    constructor Create(AOwner: TComponent); override;
    procedure Click; override;
  end;

  { YW - Cancel Button }
  TKWizardCancelButton = class(TKWizardButtonControl)
  public
    constructor Create(AOwner: TComponent); override;
    procedure Click; override;
  end;

  { YW - Help Button }
  TKWizardHelpButton = class(TKWizardButtonControl)
  public
    constructor Create(AOwner: TComponent); override;
    procedure Click; override;
  end;

{ TKWizardButtonControl }

constructor TKWizardButtonControl.Create(AOwner: TComponent);
begin
  inherited;
  if csDesigning in ComponentState then
  begin
    {$IFDEF DELPHI6}
      { !!! YW - Add csClickEvents in order to fired the Click method
         at design time. It does NOT need at run time, otherwise it cause
        the OnClick event to be called twice. }
    ControlStyle := ControlStyle + [csClickEvents];
    {$ENDIF}
    ControlStyle := ControlStyle + [csNoDesignVisible];
  end;
  Kind := bkCustom;
  Anchors := [akRight, akBottom];
end;

procedure TKWizardButtonControl.CMDesignHitTest(var Msg: TCMDesignHitTest);
begin
  inherited;
  if Enabled then
  begin
    Msg.Result := 1;
  end;
end;

procedure TKWizardButtonControl.CMVisibleChanged(var Msg: TMessage);
begin
  inherited;
  if Assigned(FWizard) then
  begin
    FWizard.RepositionButtons;
  end;
end;

{ TKWizardStartButton }

constructor TKWizardStartButton.Create(AOwner: TComponent);
begin
  inherited;
  Caption := rsFirstButtonCaption;
  Visible := False;
  Anchors := [akLeft, akBottom];
  Width := ciButtonWidth + 10;
  Alignment := alLeft;
end;

procedure TKWizardStartButton.Click;
var
  Stop: Boolean;
  Page: TKWizardCustomPage;
begin
  if Assigned(FWizard) then
  begin
    if not (csDesigning in ComponentState) then
    begin
      Stop := False;
      Page := FWizard.FActivePage;
      if Assigned(Page) and Assigned(Page.FOnStartButtonClick) then
      begin
        Page.FOnStartButtonClick(Page, Stop);
      end;
      if Stop then Exit;
      inherited;
    end;
    FWizard.SelectFirstPage;
  end;
end;

{ TKWizardLastButton }

constructor TKWizardLastButton.Create(AOwner: TComponent);
begin
  inherited;
  Caption := rsLastButtonCaption;
  Visible := False;
  Anchors := [akLeft, akBottom];
  Width := ciButtonWidth + 10;
  Alignment := alLeft;
end;

procedure TKWizardLastButton.Click;
var
  Stop: Boolean;
  Page: TKWizardCustomPage;
begin
  if Assigned(FWizard) then
  begin
    if not (csDesigning in ComponentState) then
    begin
      Stop := False;
      Page := FWizard.FActivePage;
      if Assigned(Page) and Assigned(Page.FOnLastButtonClick) then
      begin
        Page.FOnLastButtonClick(Page, Stop);
      end;
      if Stop then Exit;
      inherited;
    end;
    FWizard.SelectLastPage;
  end;
end;

{ TKWizardBackButton }

constructor TKWizardBackButton.Create(AOwner: TComponent);
begin
  inherited;
  Caption := rsBackButtonCaption;
  Enabled := False;
  Visible := True;
  Width := ciButtonWidth;
  Alignment := alRight;
end;

procedure TKWizardBackButton.Click;
var
  Stop: Boolean;
  Page: TKWizardCustomPage;
begin
  if Assigned(FWizard) then
  begin
    if not (csDesigning in ComponentState) then
    begin
      Stop := False;
      Page := FWizard.FActivePage;
      if Assigned(Page) and Assigned(Page.FOnBackButtonClick) then
      begin
        Page.FOnBackButtonClick(Page, Stop);
      end;
      if Stop then Exit;
      inherited;
    end;
    FWizard.SelectPriorPage;
  end;
end;

{ TKWizardNextButton }

constructor TKWizardNextButton.Create(AOwner: TComponent);
begin
  inherited;
  Caption := rsNextButtonCaption;
  Enabled := False;
  Visible := True;
  Width := ciButtonWidth;
  Alignment := alRight;
end;

procedure TKWizardNextButton.Click;
var
  Stop: Boolean;
  Page: TKWizardCustomPage;
begin
  if Assigned(FWizard) then
  begin
    if not (csDesigning in ComponentState) then
    begin
      Stop := False;
      Page := FWizard.FActivePage;
      if Assigned(Page) and Assigned(Page.FOnNextButtonClick) then
      begin
        Page.FOnNextButtonClick(Page, Stop);
      end;
      if Stop then Exit;
      inherited;
    end;
    FWizard.SelectNextPage;
  end;
end;

{ TKWizardFinishButton }

constructor TKWizardFinishButton.Create(AOwner: TComponent);
begin
  inherited;
  Caption := rsFinishButtonCaption;
  Visible := False;
  Width := ciButtonWidth;
  Alignment := alRight;
end;

procedure TKWizardFinishButton.Click;
var
  Stop: Boolean;
  Page: TKWizardCustomPage;
begin
  if not (csDesigning in ComponentState) and Assigned(FWizard) then
  begin
    Stop := False;
    Page := FWizard.FActivePage;
    if Assigned(Page) and Assigned(Page.FOnFinishButtonClick) then
    begin
      Page.FOnFinishButtonClick(Page, Stop);
    end;
    if Stop then Exit;
    inherited;
  end;
end;

{ TKWizardCancelButton }

constructor TKWizardCancelButton.Create(AOwner: TComponent);
begin
  inherited;
  Caption := rsCancelButtonCaption;
  Visible := True;
  Cancel := True;
  Width := ciButtonWidth;
  Alignment := alRight;
  ModalResult := mrCancel;
end;

procedure TKWizardCancelButton.Click;
var
  Stop: Boolean;
  Page: TKWizardCustomPage;
begin
  if not (csDesigning in ComponentState) and Assigned(FWizard) then
  begin
    Stop := False;
    Page := FWizard.FActivePage;
    if Assigned(Page) and Assigned(Page.FOnCancelButtonClick) then
    begin
      Page.FOnCancelButtonClick(Page, Stop);
    end;
    if Stop then Exit;
    inherited;
  end;
end;

{ TKWizardHelpButton }

constructor TKWizardHelpButton.Create(AOwner: TComponent); // Added by Theodore
begin
  inherited;
  Caption := rsHelpButtonCaption;
  Visible := False;
  Anchors := [akLeft, akBottom];
  Width := ciButtonWidth;
  Alignment := alLeft;
end;

procedure TKWizardHelpButton.Click; // Added by Theodore, Modified by Yu Wei
var
  ID: THelpContext;
begin
  ID := 0;
  if not (csDesigning in ComponentState) then
  begin
    if Assigned(FWizard) and Assigned(FWizard.ActivePage) then
      ID := FWizard.ActivePage.HelpContext
    else
      ID := GetParentForm(Self).HelpContext;
  end;
  if ID <> 0 then
  begin
    Application.HelpContext(ID);
  end;
end;

{ TKWizardNavigateButton }

function TKWizardNavigateButton.GetCaption: string;
begin
  if Assigned(FControl) then
    Result := FControl.Caption
  else
    Result := '';
end;

function TKWizardNavigateButton.GetGlyph: TBitmap;
begin
  if Assigned(FControl) then
    Result := FControl.Glyph
  else
    Result := nil;
end;

function TKWizardNavigateButton.GetLayout: TButtonLayout;
begin
  if Assigned(FControl) then
    Result := FControl.Layout
  else
    Result := blGlyphLeft;
end;

function TKWizardNavigateButton.GetNumGlyphs: Integer;
begin
  if Assigned(FControl) then
    Result := FControl.NumGlyphs
  else
    Result := 0;
end;

procedure TKWizardNavigateButton.SetCaption(const Value: string);
begin
  if Assigned(FControl) then
  begin
    FControl.Caption := Value;
  end;
end;

procedure TKWizardNavigateButton.SetGlyph(const Value: TBitmap);
begin
  if Assigned(FControl) then
  begin
    FControl.Glyph := Value;
  end;
end;

procedure TKWizardNavigateButton.SetNumGlyphs(const Value: Integer);
begin
  if Assigned(FControl) then
  begin
    FControl.NumGlyphs := Value;
  end;
end;

procedure TKWizardNavigateButton.SetLayout(const Value: TButtonLayout);
begin
  if Assigned(FControl) then
  begin
    FControl.Layout := Value;
  end;
end;

function TKWizardNavigateButton.GetModalResult: TModalResult;
begin
  if Assigned(FControl) then
    Result := FControl.ModalResult
  else
    Result := mrNone;
end;

procedure TKWizardNavigateButton.SetModalResult(const Value: TModalResult);
begin
  if Assigned(FControl) then
  begin
    FControl.ModalResult := Value;
  end;
end;

function TKWizardNavigateButton.GetButtonWidth: Integer;
begin
  if Assigned(FControl) then
    Result := FControl.Width
  else
    Result := 0;
end;

procedure TKWizardNavigateButton.SetButtonWidth(const Value: Integer);
begin
  if Assigned(FControl) and (FControl.Width <> Value) then
  begin
    FControl.Width := Value;
    if Assigned(FControl.FWizard) then
    begin
      FControl.FWizard.RepositionButtons;
    end;
  end;
end;

{ TKWizardRouteMapControl }

constructor TKWizardRouteMapControl.Create(AOwner: TComponent);
begin
  inherited;
  { !!! YW - Add csNoDesignVisible in order to make it visible and invisible
    at design Time. }
  if csDesigning in ComponentState then
  begin
    ControlStyle := ControlStyle + [csNoDesignVisible];
  end;
  FAlign := alLeft;
  inherited Align := alLeft;
  TabStop := False;
  Width := 145;
  Visible := True;
  FPages := TList.Create;
  DoubleBuffered := True;
end;

destructor TKWizardRouteMapControl.Destroy;
begin
  if Assigned(Wizard) then
  begin
    Wizard.FRouteMap := nil;
  end;
  FPages.Free;
  inherited;
end;

procedure TKWizardRouteMapControl.DoAddPage(const APage: TKWizardCustomPage);
begin
  if Assigned(FWizard) then
  begin
    if Assigned(APage) and (FPages.IndexOf(APage) < 0) then
    begin
      FPages.Add(APage);
    end;
    WizardPageAdded(APage);
  end;
end;

procedure TKWizardRouteMapControl.DoDeletePage(const APage: TKWizardCustomPage);
var
  i: Integer;
begin
  if Assigned(FWizard) then
  begin
    if Assigned(APage) then
    begin
      i := FPages.Remove(APage);
      if FPageIndex = i then
      begin
        FPageIndex := -1;
      end;
    end;
    WizardPageDeleted(APage);
  end;
end;

procedure TKWizardRouteMapControl.DoActivatePage(const APage: TKWizardCustomPage);
begin
  if Assigned(FWizard) then
  begin
    if Assigned(APage) then
    begin
      FPageIndex := FPages.IndexOf(APage);
    end;
    WizardPageActivated(APage);
  end;
end;

procedure TKWizardRouteMapControl.DoUpdatePage(const APage: TKWizardCustomPage);
begin
  if Assigned(FWizard) then
  begin
    WizardPageUpdated(APage);
  end;
end;

procedure TKWizardRouteMapControl.DoMovePage(
  const APage: TKWizardCustomPage; const OldIndex: Integer);
begin
  if Assigned(FWizard) then
  begin
    if Assigned(APage) then
    begin
      FPages.Move(OldIndex, APage.PageIndex);
      if OldIndex = FPageIndex then
      begin
        FPageIndex := APage.PageIndex;
      end;
    end;
    WizardPageMoved(APage, OldIndex);
  end;
end;

procedure TKWizardRouteMapControl.SetAlign(Value: TKWizardAlign);
begin
  if FAlign <> Value then
  begin
    FAlign := Value;
    inherited Align := FAlign;
  end;
end;

function TKWizardRouteMapControl.GetPage(Index: Integer): TKWizardCustomPage;
begin
  if (Index >= 0) and (Index < FPages.Count) then
    Result := TKWizardCustomPage(FPages[Index])
  else
    Result := nil;
end;

function TKWizardRouteMapControl.GetPageCount: Integer;
begin
  Result := FPages.Count;
end;

procedure TKWizardRouteMapControl.SetPageIndex(Value: Integer);
begin
  if (FPageIndex <> Value) and (Value >= 0) and (Value < PageCount) then
  begin
    FPageIndex := Value;
    if Assigned(FWizard) and (Pages[FPageIndex].Wizard = FWizard) then
    begin
      FWizard.SetActivePage(Pages[FPageIndex]);
    end;
  end;
end;

procedure TKWizardRouteMapControl.CMDesignHitTest(var Msg: TCMDesignHitTest);
begin
  Msg.Result := 1;
end;

function TKWizardRouteMapControl.PageAtPos(Pt: TPoint): TKWizardCustomPage;
begin
  { YW - Return the page object at the particular point in the route
    map control. Return NIL if no page at this particular point. }
  Result := nil;
end;

procedure TKWizardRouteMapControl.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  APage: TKWizardCustomPage;
begin
  if Button = mbLeft then
  begin
    APage := PageAtPos(Point(X, Y));
    if Assigned(APage) and ((csDesigning in ComponentState) or APage.Enabled) then
    begin
      PageIndex := APage.PageIndex;
    end;
  end;
  inherited;
end;

procedure TKWizardRouteMapControl.SetParent(AParent: TWinControl);
var
  i: Integer;
begin
  if Assigned(AParent) then
  begin
    if not ((AParent is TKWizard) or (AParent is TKWizardCustomPage)) then
    begin
      raise EKWizard.Create(rsInvalidParentControl);
    end;
    if AParent is TKWizardCustomPage then
    begin
      AParent := TKWizardCustomPage(AParent).Wizard;
    end;
  end;
  inherited;
  if Assigned(AParent) then
  begin
    FWizard := TKWizard(AParent);
    FWizard.FRouteMap := Self;
    FPages.Clear;
    for i := 0 to FWizard.PageCount - 1 do
    begin
      FPages.Add(FWizard.FPages[i]);
    end;
    if Assigned(FWizard.FActivePage) then
      FPageIndex := FWizard.FActivePage.PageIndex
    else
      FPageIndex := -1;
  end;
end;

procedure TKWizardRouteMapControl.WizardPageActivated(
  const APage: TKWizardCustomPage);
begin
  { YW - Called after the page becomes the current active page of wizard. }
  Invalidate;
end;

procedure TKWizardRouteMapControl.WizardPageAdded(
  const APage: TKWizardCustomPage);
begin
  { YW - Called after the new page added into wizard. }
  Invalidate;
end;

procedure TKWizardRouteMapControl.WizardPageDeleted(
  const APage: TKWizardCustomPage);
begin
  { YW - Called after the page is removed from.
     Note: do NOT free this page. }
  Invalidate;
end;

procedure TKWizardRouteMapControl.WizardPageMoved(
  const APage: TKWizardCustomPage; const OldIndex: Integer);
begin
  { YW - Called after page is changed its page order. }
  Invalidate;
end;

procedure TKWizardRouteMapControl.WizardPageUpdated(
  const APage: TKWizardCustomPage);
begin
  { YW - Called when the page change its status or caption. }
  Invalidate;
end;

function TKWizardRouteMapControl.CanDisplay(const APage: TKWizardCustomPage): Boolean;
begin
  Result := Assigned(APage) and ((csDesigning in ComponentState) or APage.Enabled);
  if not (csDesigning in ComponentState) and Assigned(FOnDisplaying) then
  begin
    FOnDisplaying(Self, APage, Result);
  end;
end;

{ TKWizardImage }

constructor TKWizardImage.Create;
begin
  FPicture := TPicture.Create;
  FAlignment := iaStretch;
  FLayout := ilStretch;
end;

destructor TKWizardImage.Destroy;
begin
  FPicture.Free;
  inherited;
end;

procedure TKWizardImage.DoChange;
begin
  if Assigned(FOnChange) then
  begin
    FOnChange(Self);
  end;
end;

procedure TKWizardImage.PaintTo(const ACanvas: TCanvas; ARect: TRect);
begin
  if Assigned(FPicture.Graphic) then
  begin
    KDrawImage(ACanvas, FPicture.Graphic, ARect, FAlignment, FLayout);
  end;
end;

procedure TKWizardImage.SetAlignment(Value: TKImageAlignment);
begin
  if FAlignment <> Value then
  begin
    FAlignment := Value;
    DoChange;
  end;
end;

procedure TKWizardImage.SetPicture(Value: TPicture);
begin
  FPicture.Assign(Value);
end;

procedure TKWizardImage.SetLayout(Value: TKImageLayout);
begin
  if FLayout <> Value then
  begin
    FLayout := Value;
    DoChange;
  end;
end;

procedure TKWizardImage.SetOnChange(Value: TNotifyEvent);
begin
  FPicture.OnChange := Value;
  FOnChange := Value;
end;

function TKWizardImage.GetTransparent: Boolean;
var
  AGraphic: TGraphic;
begin
  AGraphic := FPicture.Graphic;
  if Assigned(AGraphic) then
    Result := AGraphic.Transparent
  else
    Result := False;
end;

procedure TKWizardImage.SetTransparent(Value: Boolean);
var
  AGraphic: TGraphic;
begin
  AGraphic := FPicture.Graphic;
  if Assigned(AGraphic) and
     not ((AGraphic is TMetaFile) or (AGraphic is TIcon)) then
  begin
    AGraphic.Transparent := Value;
  end;
end;

{ TKWizardGraphicObject }

constructor TKWizardGraphicObject.Create;
begin
  FColor := clBtnFace;
  FVisible := True;
end;

procedure TKWizardGraphicObject.SetColor(Value: TColor);
begin
  if FColor <> Value then
  begin
    FColor := Value;
    ColorChanged;
  end;
end;

procedure TKWizardGraphicObject.SetVisible(Value: Boolean);
begin
  if FVisible <> Value then
  begin
    FVisible := Value;
    VisibleChanged;
  end;
end;

procedure TKWizardGraphicObject.ColorChanged;
begin
  DoChange;
end;

procedure TKWizardGraphicObject.VisibleChanged;
begin
  DoChange;
end;

{ TKWizardPageTitle }

constructor TKWizardPageTitle.Create;
begin
  inherited;
  FAnchorPlacement := 4;
  FIndent := 0;
  FAnchors := [akLeft, akTop];
  FAlignment := taLeftJustify;
  FFont := TFont.Create;
  Color := clNone; // YW - Transparent
end;

destructor TKWizardPageTitle.Destroy;
begin
  FFont.Free;
  inherited;
end;

procedure TKWizardPageTitle.DoChange;
begin
  if Assigned(FWizardPageHeader) then
  begin
    FWizardPageHeader.DoChange;
  end;
end;

procedure TKWizardPageTitle.SetWizardPageHeader(Value: TKWizardPageHeader);
begin
  if FWizardPageHeader <> Value then
  begin
    FWizardPageHeader := Value;
    if Assigned(FWizardPageHeader) and
       Assigned(FWizardPageHeader.WizardPage) then
    begin
      AdjustFont(FWizardPageHeader.WizardPage.Font);
    end;
    FFont.OnChange := OnChange;
  end;
end;

function TKWizardPageTitle.GetTextRect(const ACanvas: TCanvas;
  const ARect: TRect): TRect;
var
  ATextSize: TSize;
begin
  ATextSize := ACanvas.TextExtent(FText);
  Result := Bounds(ARect.Left, ARect.Top, ATextSize.cx, ATextSize.cy);
  if akLeft in FAnchors then
  begin
    OffsetRect(Result, FAnchorPlacement, 0);
  end;
  if akTop in FAnchors then
  begin
    OffsetRect(Result, 0, FAnchorPlacement);
  end;
  if akRight in FAnchors then
  begin
    Result.Right := ARect.Right - FAnchorPlacement;
  end;
  if akBottom in FAnchors then
  begin
    Result.Bottom := ARect.Bottom - FAnchorPlacement;
  end;
  InflateRect(Result, -FIndent, 0);
  if Result.Bottom > ARect.Bottom then
  begin
    Result.Bottom := ARect.Bottom;
  end;
  if Result.Right > ARect.Right then
  begin
    Result.Right := ARect.Right;
  end;
end;

procedure TKWizardPageTitle.PaintTo(ACanvas: TCanvas; var ARect: TRect);
const
  Alignments: array[TAlignment] of Integer = (DT_LEFT, DT_CENTER, DT_RIGHT);
var
  ATextRect: TRect;
begin
  if FVisible and Assigned(FWizardPageHeader) and
     Assigned(FWizardPageHeader.WizardPage) then
  begin
    ACanvas.Font.Assign(FFont);
    ATextRect := GetTextRect(ACanvas, ARect);
    if FColor <> clNone then
    begin
      ACanvas.Brush.Style := bsSolid;
      ACanvas.Brush.Color := FColor;
      ACanvas.FillRect(ATextRect);
    end;
    with ACanvas do
    begin
      Brush.Style := bsClear;
      DrawText(ACanvas.Handle, PChar(FText), -1, ATextRect,
               DT_WORDBREAK + Alignments[FAlignment]);
      { YW - Draw outline at design time. }
      if csDesigning in FWizardPageHeader.WizardPage.ComponentState then
      begin
        Pen.Style := psDot;
        Pen.Mode := pmXor;
        Pen.Color := $00FFD8CE;
        Brush.Style := bsClear;
        Rectangle(ATextRect.Left, ATextRect.Top, ATextRect.Right,
          ATextRect.Bottom);
      end;
    end;
    ARect.Top := ATextRect.Bottom;
  end;
end;

procedure TKWizardPageTitle.SetAlignment(Value: TAlignment);
begin
  if FAlignment <> Value then
  begin
    FAlignment := Value;
    DoChange;
  end;
end;

procedure TKWizardPageTitle.SetAnchors(Value: TAnchors);
begin
  if FAnchors <> Value then
  begin
    FAnchors := Value;
    DoChange;
  end;
end;

procedure TKWizardPageTitle.SetIndent(Value: Integer);
begin
  if FIndent <> Value then
  begin
    FIndent := Value;
    DoChange;
  end;
end;

procedure TKWizardPageTitle.SetFont(Value: TFont);
begin
  if (FFont <> Value) and
     not (Assigned(FWizardPageHeader) and FWizardPageHeader.ParentFont) then
  begin
    FFont.Assign(Value);
  end;
end;

procedure TKWizardPageTitle.SetText(Value: string);
begin
  if FText <> Value then
  begin
    FText := Value;
    DoChange;
    if Assigned(FWizardPageHeader) and
       Assigned(FWizardPageHeader.WizardPage) and
       Assigned(FWizardPageHeader.WizardPage.Wizard) and
       Assigned(FWizardPageHeader.WizardPage.Wizard.FRouteMap) then
    begin
      FWizardPageHeader.WizardPage.Wizard.FRouteMap.DoUpdatePage(
        FWizardPageHeader.WizardPage);
    end;
  end;
end;

procedure TKWizardPageTitle.SetAnchorPlacement(Value: Integer);
begin
  if FAnchorPlacement <> Value then
  begin
    FAnchorPlacement := Value;
    DoChange;
  end;
end;

procedure TKWizardPageTitle.AdjustFont(const AFont: TFont);
begin
  if Assigned(AFont) then
  begin
    FFont.Name := AFont.Name;
    FFont.Charset := AFont.Charset;
  end;
end;

procedure TKWizardPageTitle.OnChange(Sender: TObject);
begin
  DoChange;
end;

{ TKWizardPageObject }

procedure TKWizardPageObject.DoChange;
begin
  if Assigned(FWizardPage) then
  begin
    FWizardPage.Invalidate;
  end;
end;

procedure TKWizardPageObject.Initialize;
begin
end;

procedure TKWizardPageObject.SetWizardPage(Value: TKWizardCustomPage);
begin
  FWizardPage := Value;
  Initialize;
end;

{ TKWizardPageHeader }

constructor TKWizardPageHeader.Create;
begin
  inherited;
  Color := clWindow;
  FHeight := 70;
  FParentFont := True;
  { Set up Title }
  FTitle := TKWizardPageTitle.Create;
  FTitle.FText := rsTitle;
  FTitle.FAnchors := [akLeft, akTop, akRight];
  FTitle.FFont.Size := 12;
  FTitle.FFont.Style := [fsBold];
  { Set up Subtitle }
  FSubtitle := TKWizardPageTitle.Create;
  FSubtitle.FAnchors := [akLeft, akTop, akRight, akBottom];
  FSubtitle.FText := rsSubtitle;
  FImageAlignment := iaRight;
  FImageOffset := 0;
  FImageIndex := -1;
  FShowDivider := True;
end;

destructor TKWizardPageHeader.Destroy;
begin
  FTitle.Free;
  FSubtitle.Free;
  inherited;
end;

procedure TKWizardPageHeader.Initialize;
begin
  FTitle.WizardPageHeader := Self;
  FSubtitle.WizardPageHeader := Self;
end;

procedure TKWizardPageHeader.SetHeight(Value: Integer);
begin
  if FHeight <> Value then
  begin
    FHeight := Value;
    DoChange;
  end;
end;

procedure TKWizardPageHeader.SetImageIndex(Value: Integer);
begin
  if FImageIndex <> Value then
  begin
    FImageIndex := Value;
    DoChange;
  end;
end;

procedure TKWizardPageHeader.SetImageOffset(Value: Integer);
begin
  if FImageOffset <> Value then
  begin
    FImageOffset := Value;
    DoChange;
  end;
end;

procedure TKWizardPageHeader.SetImageAlignment(Value: TKImageLeftRight);
begin
  if FImageAlignment <> Value then
  begin
    FImageAlignment := Value;
    DoChange;
  end;
end;

procedure TKWizardPageHeader.SetShowDivider(Value: Boolean);
begin
  if FShowDivider <> Value then
  begin
    FShowDivider := Value;
    DoChange;
  end;
end;

function TKWizardPageHeader.GetImageRect(const AImages: TCustomImageList;
  var ARect: TRect): TRect;
begin
  Result := Bounds(ARect.Left, ARect.Top, AImages.Width, AImages.Height);
  OffsetRect(Result, 0, ((ARect.Bottom - ARect.Top) - AImages.Height) div 2);
  if FImageAlignment = iaRight then
  begin
    OffsetRect(Result, ARect.Right - ARect.Left - AImages.Width - 4, 0);
  end;
  OffsetRect(Result, FImageOffset, 0);
  if FImageAlignment = iaLeft then
  begin
    { YW - if right side of the image area still in the page header area
      then adjust the left side of title area. }
    if Result.Right > ARect.Left then
      ARect.Left := Result.Right;
  end
  else // must be iaRight
  begin
    { YW - if left side of the image area still in the page header area
      then adjust the ride side of title area. }
    if Result.Left < ARect.Right then
      ARect.Right := Result.Left;
  end;
end;

procedure TKWizardPageHeader.PaintTo(ACanvas: TCanvas; var ARect: TRect);
var
  R, ImageRect: TRect;
  AImages: TCustomImageList;
begin
  if Visible then
  begin
    R := ARect;
    R.Bottom := R.Top + FHeight;
    with ACanvas do
    begin
      Brush.Style := bsSolid;
      Brush.Color := Color;
      FillRect(R);
    end;
    if Assigned(WizardPage) then
    begin
      { YW - Show Header Divider }
      if (csDesigning in WizardPage.ComponentState) or FShowDivider then
      begin
        KDrawBorderEdges(ACanvas, R, fsGroove, [beBottom]);
      end;
      { YW - Draw Header Image first }
      if Assigned(WizardPage.Wizard) then
      begin
        AImages := WizardPage.Wizard.HeaderImages;
        if Assigned(AImages) and (FImageIndex >= 0) and
          (FImageIndex < AImages.Count) then
        begin
          ImageRect := GetImageRect(AImages, R);
          { YW - R is the area where the title and subtitle paint to. }
          AImages.Draw(ACanvas, ImageRect.Left, ImageRect.Top, FImageIndex, True);
        end;
      end;
      { YW - Draw Title }
      FTitle.PaintTo(ACanvas, R);
      { YW - Draw Subtitle }
      FSubtitle.PaintTo(ACanvas, R);
    end;
    Inc(ARect.Top, FHeight);
  end;
end;

procedure TKWizardPageHeader.AdjustTitleFont;
begin
  if Assigned(FWizardPage) and FParentFont then
  begin
    if Assigned(FTitle) then
    begin
      FTitle.AdjustFont(FWizardPage.Font);
    end;
    if Assigned(FSubtitle) then
    begin
      FSubtitle.AdjustFont(FWizardPage.Font);
    end;
  end;
end;

procedure TKWizardPageHeader.SetParentFont(Value: Boolean);
begin
  if FParentFont <> Value then
  begin
    FParentFont := Value;
    AdjustTitleFont;
  end;
end;

procedure TKWizardPageHeader.VisibleChanged;
begin
  inherited; // !!!
  if Assigned(WizardPage) then
  begin
    WizardPage.Realign;
  end;
end;

{ TKWizardWaterMark }

constructor TKWizardWaterMark.Create;
begin
  inherited;
  FAlign := alLeft;
  Color := clActiveCaption;
  FWidth := 164;
  FBorderWidth := 1;
  FImage := TKWizardImage.Create;
  FImage.OnChange := ImageChanged;
end;

destructor TKWizardWaterMark.Destroy;
begin
  FImage.Free;
  inherited;
end;

procedure TKWizardWaterMark.SetBorderWidth(Value: Integer);
begin
  if FBorderWidth <> Value then
  begin
    FBorderWidth := Value;
    DoChange;
  end;
end;

procedure TKWizardWaterMark.SetAlign(Value: TKWizardLeftRight);
begin
  if FAlign <> Value then
  begin
    FAlign := Value;
    DoChange;
    if Assigned(WizardPage) then
    begin
      WizardPage.Realign;
    end;
  end;
end;

procedure TKWizardWaterMark.SetWidth(Value: Integer);
begin
  if FWidth <> Value then
  begin
    FWidth := Value;
    DoChange;
  end;
end;

procedure TKWizardWaterMark.PaintTo(ACanvas: TCanvas; var ARect: TRect);
var
  R: TRect;
  AHeight: Integer;
begin
  if Visible then
  begin
    AHeight := ARect.Bottom - ARect.Top;
    if FAlign = alLeft then
    begin
      R := Bounds(ARect.Left, ARect.Top, FWidth, AHeight);
      Inc(ARect.Left, FWidth);
    end
    else // YW - must be alRight
    begin
      R := Bounds(ARect.Right - FWidth, ARect.Top, FWidth, AHeight);
      Dec(ARect.Right, FWidth);
    end;
    InflateRect(R, -FBorderWidth, -FBorderWidth);
    with ACanvas do
    begin
      Brush.Style := bsSolid;
      Brush.Color := Color;
      FillRect(R);
    end;
    FImage.PaintTo(ACanvas, R);
  end;
end;

procedure TKWizardWaterMark.ImageChanged(Sender: TObject);
begin
  DoChange;
end;

procedure TKWizardWaterMark.VisibleChanged;
begin
  inherited; // !!!
  if Assigned(WizardPage) then
  begin
    WizardPage.Realign;
  end;
end;

{ TKWizardPagePanel }

constructor TKWizardPagePanel.Create;
begin
  inherited;
  FBorderWidth := 7;
  Color := clBtnFace;
  Visible := False;
end;

procedure TKWizardPagePanel.PaintTo(ACanvas: TCanvas; var ARect: TRect);
begin
  if Visible and (FBorderWidth > 0) then
  begin
    InflateRect(ARect, -FBorderWidth, -FBorderWidth);
    KDrawBorderEdges(ACanvas, ARect, fsGroove, beAllEdges);
    if Color <> clNone then  // YW - clNone means transparent
    begin
      InflateRect(ARect, -2, -2);
      with ACanvas do
      begin
        Brush.Style := bsSolid;
        Brush.Color := Color;
        FillRect(ARect);
      end;
    end;
  end;
end;

procedure TKWizardPagePanel.SetBorderWidth(Value: Word);
begin
  if FBorderWidth <> Value then
  begin
    FBorderWidth := Value;
    DoChange;
  end;
end;

{ TKWizardCustomPage }

constructor TKWizardCustomPage.Create(AOwner: TComponent);
begin
  inherited;
  Align := alClient;
  ControlStyle := ControlStyle + [csAcceptsControls, csNoDesignVisible];
  Visible := False;
  Color := clBtnFace;
  FHeader := TKWizardPageHeader.Create;
  FHeader.WizardPage := Self;
  FImage := TKWizardImage.Create;
  FImage.OnChange := ImageChanged;
  FPanel := TKWizardPagePanel.Create;
  FPanel.WizardPage := Self;
  { YW - try to avoid screen flicker, it paints its image
    into memory, then move image memory to the screen at once. }
  FEnabledButtons := bkAllButtons;
  FVisibleButtons := [bkBack, bkNext, bkCancel];
  DoubleBuffered := True;
end;

destructor TKWizardCustomPage.Destroy;
begin
  if Assigned(FWizard) then
  begin
    FWizard.RemovePage(Self);
  end;
  FPanel.Free;
  FImage.Free;
  FHeader.Free;
  inherited;
end;

procedure TKWizardCustomPage.CreateParams(var Params: TCreateParams);
begin
  inherited;
  with Params.WindowClass do
  begin
    Style := Style and not (CS_HREDRAW or CS_VREDRAW);
  end;
end;

procedure TKWizardCustomPage.AdjustClientRect(var Rect: TRect);
begin
  inherited;
  if FHeader.Visible then
  begin
    Rect.Top := Rect.Top + FHeader.Height;
  end;
end;

procedure TKWizardCustomPage.CMEnabledChanged(var Message: TMessage);
var
  NextPage: TKWizardCustomPage;
begin
  inherited;
  if Assigned(FWizard) then
  begin
    if Assigned(FWizard.FRouteMap) then
    begin
      FWizard.FRouteMap.DoUpdatePage(Self);
    end;
    if not ((csDesigning in ComponentState) or Enabled) and
       (FWizard.ActivePage = Self) then
    begin
      NextPage := FWizard.FindNextPage(PageIndex, 1,
        not (csDesigning in ComponentState));
      if not Assigned(NextPage) then
      begin
        NextPage := FWizard.FindNextPage(PageIndex, -1,
          not (csDesigning in ComponentState));
      end;
      FWizard.SetActivePage(NextPage);
    end;
  end;
end;

procedure TKWizardCustomPage.CMTextChanged(var Message: TMessage);
begin
  Invalidate;
  if Assigned(FWizard) and Assigned(FWizard.FRouteMap) then
  begin
    FWizard.FRouteMap.DoUpdatePage(Self);
  end;
end;

procedure TKWizardCustomPage.CMFontChanged(var Message: TMessage);
begin
  FHeader.AdjustTitleFont;
  inherited;
end;

procedure TKWizardCustomPage.SetWizard(AWizard: TKWizard);
begin
  if FWizard <> AWizard then
  begin
    if Assigned(FWizard) then
    begin
      FWizard.RemovePage(Self);
    end;
    Parent := AWizard;
    if Assigned(AWizard) then
    begin
      AWizard.InsertPage(Self);
    end;
  end;
end;

function TKWizardCustomPage.GetPageIndex: Integer;
begin
  if Assigned(FWizard) then
    Result := FWizard.FPages.IndexOf(Self)
  else
    Result := -1;
end;

procedure TKWizardCustomPage.ReadState(Reader: TReader);
begin
  inherited;
  if Reader.Parent is TKWizard then
  begin
    Wizard := TKWizard(Reader.Parent);
  end;
end;

procedure TKWizardCustomPage.SetPageIndex(const Value: Integer);
var
  OldIndex: Integer;
begin
  if Assigned(FWizard) and (Value >= 0) and (Value < FWizard.FPages.Count) then
  begin
    OldIndex := PageIndex;
    FWizard.FPages.Move(OldIndex, Value);
    if Assigned(FWizard.FRouteMap) then
    begin
      FWizard.FRouteMap.DoMovePage(Self, OldIndex);
    end;
  end;
end;

procedure TKWizardCustomPage.WMEraseBkgnd(var Message: TWmEraseBkgnd);
begin
  Message.Result := 1;
end;

procedure TKWizardCustomPage.Paint;
var
  ARect: TRect;
begin
  if FDrawing then System.Exit;
  FDrawing := True;
  try
    ARect := ClientRect;
    with Canvas do
    begin
      Brush.Style := bsSolid;
      Brush.Color := Color;
      FillRect(ARect);
    end;
    DrawPage(Canvas, ARect);
    if Assigned(FOnPaintPage) and not (csDesigning in ComponentState) then
      FOnPaintPage(Self, Canvas, ARect)
    else
    begin
      { YW - Paint the image first to prevent the image from covering
        the panel. }
      FImage.PaintTo(Canvas, ARect);
      FPanel.PaintTo(Canvas, ARect);
    end;
    { YW - display page caption at design time. }
    if csDesigning in ComponentState then
    begin
      Canvas.Brush.Style := bsClear;
      Canvas.Font.Assign(Font);
      DrawText(Canvas.Handle, PChar(Caption), -1, ARect,
               DT_SINGLELINE + DT_CENTER + DT_VCENTER);
    end;
  finally
    FDrawing := False;
  end;
end;

procedure TKWizardCustomPage.DrawPage(ACanvas: TCanvas; var ARect: TRect);
begin
  { YW - all derived page control should call this method to paint itsself
    rather than call the overrided paint method. }
end;

procedure TKWizardCustomPage.Done;
begin
  Refresh; // !!! YW - Force the page to repaint itself immediately.
  if Assigned(FOnPage) and Enabled and not (csDesigning in ComponentState) then
  begin
    FOnPage(Self);
  end;
end;

procedure TKWizardCustomPage.Enter(const FromPage: TKWizardCustomPage);
begin
  if Assigned(FOnEnterPage) and Enabled and
     not (csDesigning in ComponentState) then
  begin
    FOnEnterPage(Self, FromPage);
  end;
end;

procedure TKWizardCustomPage.Exit(const ToPage: TKWizardCustomPage);
begin
  if Assigned(FOnExitPage) and Enabled and
     not (csDesigning in ComponentState) then
  begin
    FOnExitPage(Self, ToPage);
  end;
end;

procedure TKWizardCustomPage.ImageChanged(Sender: TObject);
begin
  Invalidate;
end;

procedure TKWizardCustomPage.SetEnabledButtons(Value: TKWizardButtonSet);
begin
  if FEnabledButtons <> Value then
  begin
    FEnabledButtons := Value;
    if Assigned(FWizard) and (FWizard.FActivePage = Self) then
    begin
      FWizard.UpdateButtonsStatus;
    end;
  end;
end;

procedure TKWizardCustomPage.SetVisibleButtons(Value: TKWizardButtonSet);
begin
  if FVisibleButtons <> Value then
  begin
    FVisibleButtons := Value;
    if Assigned(FWizard) and (FWizard.FActivePage = Self) then
    begin
      { YW - if there is no buttons are visible, then we don't need
        to display the button bar. }
      if FVisibleButtons = [] then
        FWizard.ButtonBarHeight := 0
      else
        FWizard.ButtonBarHeight := ciButtonBarHeight;
      Invalidate;
    end;
  end;
end;

{ TKWizardWelcomePage }

constructor TKWizardWelcomePage.Create(AOwner: TComponent);
begin
  inherited;
  FWaterMark := TKWizardWaterMark.Create;
  FWaterMark.WizardPage := Self;
  FHeader.FTitle.FText := rsWelcome;
  FHeader.FShowDivider := False;
  Color := clWindow;
end;

destructor TKWizardWelcomePage.Destroy;
begin
  FWaterMark.Free;
  inherited;
end;

procedure TKWizardWelcomePage.AdjustClientRect(var Rect: TRect);
begin
  inherited; // !!! YW - must call
  if FWaterMark.Visible then
  begin
    if FWaterMark.Align = alLeft then
      Rect.Left := Rect.Left + FWaterMark.Width
    else
      Rect.Right := Rect.Right - FWaterMark.Width;
  end;
end;

procedure TKWizardWelcomePage.DrawPage(ACanvas: TCanvas; var ARect: TRect);
begin
  FWaterMark.PaintTo(ACanvas, ARect);
  FHeader.PaintTo(ACanvas, ARect);
end;

{ TKWizardInteriorPage }

procedure TKWizardInteriorPage.DrawPage(ACanvas: TCanvas; var ARect: TRect);
begin
  FHeader.PaintTo(ACanvas, ARect);
end;

{ TKWizardPageList }

destructor TKWizardPageList.Destroy;
begin
  FWizard := nil;
  inherited;
end;

procedure TKWizardPageList.Notify(Ptr: Pointer; Action: TListNotification);
begin
  case Action of
    lnAdded:
      begin
        TKWizardCustomPage(Ptr).FWizard := FWizard;
      end;
    lnDeleted:
      begin
        TKWizardCustomPage(Ptr).FWizard := nil;
      end;
  end;
end;

{ TKWizard }

constructor TKWizard.Create(AComponent: TComponent);
begin
  inherited;
  { YW - In order to accept TKWizardRouteMap control, we need to add
    csAcceptsControls ControlStyle }
  ControlStyle := ControlStyle + [csAcceptsControls];
  FPages := TKWizardPageList.Create;
  FPages.Wizard := Self;
  Align := alClient;
  FShowDivider := True;
  FButtonBarHeight := ciButtonBarHeight;
  FImageChangeLink := TChangeLink.Create;
  FImageChangeLink.OnChange := ImageListChange;
  CreateNavigateButtons;
end;

destructor TKWizard.Destroy;
var
  i: Integer;
  AKind: TKWizardButtonKind;
begin
  for AKind := Low(TKWizardButtonKind) to High(TKWizardButtonKind) do
  begin
    FNavigateButtons[AKind].Free;
  end;
  { !!! YW - Reset wizard property value of all wizard pages FIRST,
    so that when the actual wizard page control is freed, the page won't
    call Wizard.RemovePage, otherwise it will cause AV, because at that
    time FPages has already been destroyed. }
  for i := 0 to FPages.Count - 1 do
  begin
    TKWizardCustomPage(FPages[i]).FWizard := nil;
  end;
  FImageChangeLink.Free;
  FPages.Free;
  inherited;
end;

procedure TKWizard.Loaded;
begin
  inherited;
  RepositionButtons;
  { YW - When the wizard shows up, by default we display the first page. }
  if FPages.Count > 0 then
  begin
    SelectFirstPage;
  end;
end;

function TKWizard.GetButtonControlClass(
  AKind: TKWizardButtonKind): TKWizardButtonControlClass;
begin
  case AKind of
    bkStart:  Result := TKWizardStartButton;
    bkLast:   Result := TKWizardLastButton;
    bkBack:   Result := TKWizardBackButton;
    bkNext:   Result := TKWizardNextButton;
    bkFinish: Result := TKWizardFinishButton;
    bkCancel: Result := TKWizardCancelButton;
    bkHelp:   Result := TKWizardHelpButton;
  else
    Result := TKWizardButtonControl;
  end;
end;

procedure TKWizard.CreateNavigateButtons;
var
  AKind: TKWizardButtonKind;
  AButton: TKWizardButtonControl;
begin
  for AKind := Low(TKWizardButtonKind) to High(TKWizardButtonKind) do
  begin
    { YW - Don't need to set width property }
    AButton := GetButtonControlClass(AKind).Create(Self);
    try
      AButton.Parent := Self;
      AButton.Height := ciButtonHeight;
      AButton.Wizard := Self;
    finally
      FNavigateButtons[AKind] := TKWizardNavigateButton.Create;
      FNavigateButtons[AKind].Control := AButton;
    end;
  end;
end;

function TKWizard.FindNextPage(PageIndex: Integer; const Step: Integer = 1;
  CheckDisable: Boolean = True): TKWizardCustomPage;
begin
  { !!! YW - Only the Enabled property of the page can tell if it should be
     ignore or skip. we can not use Visible property, because all pages are
     invisible at startup until they are actived. }
  Result := nil;
  repeat
    Inc(PageIndex, Step);
  until (PageIndex < 0) or (PageIndex >= FPages.Count) or
        TKWizardCustomPage(FPages[PageIndex]).Enabled or not CheckDisable;
  if csDesigning in ComponentState then
  begin
    if PageIndex < 0 then
      PageIndex := FPages.Count - 1
    else if PageIndex >= FPages.Count then
      PageIndex := 0;
  end;
  if (PageIndex >= 0) and (PageIndex < FPages.Count) and
     (TKWizardCustomPage(FPages[PageIndex]).Enabled or not CheckDisable) then
    Result := TKWizardCustomPage(FPages[PageIndex]);
end;

procedure TKWizard.SelectFirstPage;
var
  AFirstPage: TKWizardCustomPage;
begin
  AFirstPage := FindNextPage(-1, 1, not (csDesigning in ComponentState));
  if Assigned(AFirstPage) then
  begin
    if not (csDesigning in ComponentState) and Assigned(FOnSelectFirstPage) then
      FOnSelectFirstPage(Self, FActivePage, AFirstPage);
    if Assigned(AFirstPage) then
      SetActivePage(AFirstPage);
  end;
end;

procedure TKWizard.SelectLastPage;
var
  ALastPage: TKWizardCustomPage;
begin
  ALastPage := FindNextPage(FPages.Count, -1,
    not (csDesigning in ComponentState));
  if Assigned(ALastPage) then
  begin
    if not (csDesigning in ComponentState) and Assigned(FOnSelectLastPage) then
      FOnSelectLastPage(Self, FActivePage, ALastPage);
    if Assigned(ALastPage) then
      SetActivePage(ALastPage);
  end;
end;

procedure TKWizard.SelectNextPage;
var
  ANextPage: TKWizardCustomPage;
begin
  ANextPage := FindNextPage(GetActivePageIndex, 1,
    not (csDesigning in ComponentState));
  if Assigned(ANextPage) then
  begin
    if not (csDesigning in ComponentState) and Assigned(FOnSelectNextPage) then
      FOnSelectNextPage(Self, FActivePage, ANextPage);
    if Assigned(ANextPage) then
      SetActivePage(ANextPage);
  end;
end;

procedure TKWizard.SelectPriorPage;
var
  APriorPage: TKWizardCustomPage;
begin
  APriorPage := FindNextPage(GetActivePageIndex, -1,
    not (csDesigning in ComponentState));
  if Assigned(APriorPage) then
  begin
    if not (csDesigning in ComponentState) and Assigned(FOnSelectPriorPage) then
      FOnSelectPriorPage(Self, FActivePage, APriorPage);
    if Assigned(APriorPage) then
      SetActivePage(APriorPage);
  end;
end;

function TKWizard.IsFirstPage(const APage: TKWizardCustomPage;
  CheckDisable: Boolean = True): Boolean;
var
  AFirstPage: TKWizardCustomPage;
begin
  AFirstPage := FindNextPage(-1, 1, CheckDisable);
  Result := not Assigned(AFirstPage) or (APage = AFirstPage);
end;

function TKWizard.IsLastPage(const APage: TKWizardCustomPage;
  CheckDisable: Boolean = True): Boolean;
var
  ALastPage: TKWizardCustomPage;
begin
  ALastPage := FindNextPage(FPages.Count, -1, CheckDisable);
  Result := not Assigned(ALastPage) or (APage = ALastPage);
end;

procedure TKWizard.SetActivePage(Page: TKWizardCustomPage);
begin
  if not (csLoading in ComponentState) and
    (not Assigned(Page) or ((Page.Wizard = Self) and
     ((csDesigning in ComponentState) or Page.Enabled))) then
  begin
    ChangeActivePage(Page);
  end;
end;

procedure TKWizard.ChangeActivePage(Page: TKWizardCustomPage);
var
  ParentForm: TCustomForm;
begin
  if FActivePage <> Page then
  begin
    ParentForm := GetParentForm(Self);
    if Assigned(ParentForm) and Assigned(FActivePage) and
       FActivePage.ContainsControl(ParentForm.ActiveControl) then
    begin
      ParentForm.ActiveControl := FActivePage;
    end;

    if Assigned(FActivePage) then
    begin
      { YW - FActivePage.Exit, called just before the page is hidden. }
      FActivePage.Exit(Page);
      FActivePage.Visible := False;
    end;

    { YW - Just in case the new page is changed to be disabled again after
      the above OnExitPage event is called. }
    if Assigned(Page) and not (Page.Enabled
      or (csDesigning in ComponentState)) then
    begin
      if IsForward(FActivePage, Page) then
        Page := FindNextPage(GetActivePageIndex) // try go forward
      else
        Page := FindNextPage(GetActivePageIndex, -1); // try go backward
    end;

    if Assigned(Page) then
    begin
      { YW - FActivePage.Enter, called before the page shows up. }
      Page.Enter(FActivePage);
      Page.BringToFront;
      Page.Visible := True;
      if Assigned(ParentForm) then
      begin
        if Page.CanFocus then
          ParentForm.ActiveControl := Page
        else
          ParentForm.ActiveControl := Self;
      end;
    end;

    FActivePage := Page;
    if Assigned(FRouteMap) then
    begin
      FRouteMap.DoActivatePage(FActivePage);
    end;
    if Assigned(FActivePage) and (FActivePage.FVisibleButtons = []) then
      ButtonBarHeight := 0
    else
      ButtonBarHeight := ciButtonBarHeight;
    { YW - At design time, if the Page's Enabled property set to false,
      the following if block never gets called. }
    if Assigned(ParentForm) and Assigned(FActivePage) and
       (ParentForm.ActiveControl = FActivePage) then
    begin
      FActivePage.Done;
      FActivePage.SelectFirst;
    end;
  end;
end;

procedure TKWizard.InsertPage(Page: TKWizardCustomPage);
begin
  FPages.Add(Page);
  if Assigned(FRouteMap) then
  begin
    FRouteMap.DoAddPage(Page);
  end;
end;

procedure TKWizard.RemovePage(Page: TKWizardCustomPage);
var
  NextPage: TKWizardCustomPage;
begin
  NextPage := FindNextPage(Page.PageIndex, 1, not (csDesigning in ComponentState));
  if NextPage = Page then 
  begin
    NextPage := nil;
  end;
  if Assigned(FRouteMap) then
  begin
    FRouteMap.DoDeletePage(Page);
  end;
  FPages.Remove(Page);
  SetActivePage(NextPage);
  { !!! YW - We must not call Page.Free, becaure page is the child
    control of the wizard now, so when the wizard being destroy, this page
    will be destroyed as well. }
end;

function TKWizard.GetActivePageIndex: Integer;
begin
  if Assigned(ActivePage) then
    Result := ActivePage.PageIndex
  else
    Result := -1;
end;

procedure TKWizard.SetActivePageIndex(Value: Integer);
begin
  if (Value >= 0) and (Value < PageCount) then
    ActivePage := TKWizardCustomPage(FPages[Value])
  else
    ActivePage := nil;
end;

procedure TKWizard.WMEraseBkgnd(var Message: TWMEraseBkgnd);
begin
  Message.Result := 1;
end;

procedure TKWizard.Paint;
var
  R: TRect;
begin
  R := ClientRect;
  if Color <> clNone then
  begin
    Canvas.Brush.Color := Color;
    Canvas.Brush.Style := bsSolid;
    Canvas.FillRect(R);
  end;
  if (FButtonBarHeight > ciButtonHeight) and FShowDivider then
  begin
    R.Top := R.Bottom - FButtonBarHeight;
    KDrawBorderEdges(Canvas, R, fsGroove, [beTop]);
  end;
end;

procedure TKWizard.SetShowDivider(Value: Boolean);
begin
  if FShowDivider <> Value then
  begin
    FShowDivider := Value;
    Invalidate;
  end;
end;

function TKWizard.GetShowRouteMap: Boolean;
begin
  if Assigned(FRouteMap) then
    Result := FRouteMap.Visible
  else
    Result := False;
end;

procedure TKWizard.SetShowRouteMap(Value: Boolean);
begin
  if Assigned(FRouteMap) then
  begin
    FRouteMap.Visible := Value;
  end;
end;

procedure TKWizard.SetButtonBarHeight(Value: Integer);
begin
  if FButtonBarHeight <> Value then
  begin
    FButtonBarHeight := Value;
    Realign;
    RepositionButtons;
    Invalidate;
  end;
  { YW - Whatever the ButtonBarHeight is changed or not, we need to
     call UpdateButtonsStatus method anyway. }
  UpdateButtonsStatus;
end;

procedure TKWizard.SetHeaderImages(Value: TCustomImageList);
begin
  if Assigned(FHeaderImages) then
  begin
    FHeaderImages.UnRegisterChanges(FImageChangeLink);
  end;
  FHeaderImages := Value;
  if Assigned(FHeaderImages) then
  begin
    FHeaderImages.RegisterChanges(FImageChangeLink);
    FHeaderImages.FreeNotification(Self);
  end;
  if Assigned(FActivePage) then
  begin
    FActivePage.Invalidate;
  end;
end;

function TKWizard.GetButtonClick(const Index: TKWizardButtonKind): TNotifyEvent;
begin
  if Assigned(FNavigateButtons[Index].Control) then
    Result := FNavigateButtons[Index].Control.OnClick
  else
    Result := nil;
end;

procedure TKWizard.SetButtonClick(const Index: TKWizardButtonKind;
  const Value: TNotifyEvent);
begin
  if Assigned(FNavigateButtons[Index].Control) then
  begin
    FNavigateButtons[Index].Control.OnClick := Value;
  end;
end;

function TKWizard.GetPageCount: Integer;
begin
  Result := FPages.Count;
end;

procedure TKWizard.CMDesignHitTest(var Message: TCMDesignHitTest);
var
  Pt: TPoint;
begin
  Pt := SmallPointToPoint(Message.Pos);
  if Assigned(FActivePage) and PtInRect(FActivePage.BoundsRect, Pt) then
  begin
    Message.Result := 1;
  end;
end;

procedure TKWizard.AdjustClientRect(var Rect: TRect);
begin
  { YW - All wizard's child controls (Pages, RouteMap, etc) whose align
     property set to (alTop, alLeft, alTop, alBottom, alClient) will call
     this procedure to adjust their bounds. All navigation buttons would not
     call it because they do not have align set, so they can display at
     the bottom of the wizard. }
  inherited;
  if FButtonBarHeight > ciButtonHeight then
  begin
    Rect.Bottom := Rect.Bottom - FButtonBarHeight;
  end;
end;

procedure TKWizard.WMGetDlgCode(var Message: TWMGetDlgCode);
begin
  Message.Result := DLGC_WANTALLKEYS or DLGC_WANTARROWS;
end;

procedure TKWizard.UpdateButtonsStatus;
var
  AKind: TKWizardButtonKind;
  AEnabledButtonSet: TKWizardButtonSet;
  AVisibleButtonSet: TKWizardButtonSet;
begin
  AEnabledButtonSet := [bkCancel];
  AVisibleButtonSet := [bkBack, bkNext, bkCancel];
  if Assigned(FActivePage) then
  begin
    { YW - By default, the Back button should be disabled for the first
       page at run time }
    if not (csDesigning in ComponentState) and IsFirstPage(FActivePage) then
    begin
      Exclude(FActivePage.FEnabledButtons, bkBack);
    end;
    AEnabledButtonSet := FActivePage.FEnabledButtons;
    AVisibleButtonSet := FActivePage.FVisibleButtons;
    if csDesigning in ComponentState then
    begin
      Include(AEnabledButtonSet, bkBack);
      Include(AEnabledButtonSet, bkNext);
      Include(AVisibleButtonSet, bkBack);
      Include(AVisibleButtonSet, bkNext);
      Exclude(AVisibleButtonSet, bkFinish);
    end;
  end;
  { YW - Change Buttons' status. }
  for AKind := Low(TKWizardButtonKind) to High(TKWizardButtonKind) do
  begin
    FNavigateButtons[AKind].Control.Visible := AKind in AVisibleButtonSet;
    FNavigateButtons[AKind].Control.Enabled := AKind in AEnabledButtonSet;
  end;
  { YW - Set Default Button, Next Button has the higher priority than
     the Finish Button. }
  if (bkNext in AVisibleButtonSet) and (bkNext in AEnabledButtonSet) then
    FNavigateButtons[bkNext].Control.Default := True
  else if (bkFinish in AVisibleButtonSet) and (bkFinish in AEnabledButtonSet) then
    FNavigateButtons[bkFinish].Control.Default := True;
end;

procedure TKWizard.RepositionButtons;
var
  ATop: Integer;
  ALeft: Integer;
  AButtonSet: TKWizardButtonSet;
  AButtonKind: TKWizardButtonKind;

  procedure LocateButton(const AKind: TKWizardButtonKind;
    const AOffset: Integer);
  begin
    if AKind in AButtonSet then
    begin
      with FNavigateButtons[AKind] do
      begin
        if FControl.Alignment = alRight then
          ALeft := ALeft - FControl.Width;
        FControl.SetBounds(ALeft, ATop, FControl.Width, ciButtonHeight);
        if FControl.Alignment = alLeft then
          ALeft := ALeft + FControl.Width;
      end;
      ALeft := ALeft + AOffset;
    end;
  end;

begin
  if FButtonBarHeight > ciButtonHeight then
  begin
    AButtonSet := [bkBack, bkNext, bkCancel];
    if Assigned(FActivePage) then
    begin
      AButtonSet := FActivePage.FVisibleButtons;
      if csDesigning in ComponentState then
      begin
        Include(AButtonSet, bkBack);
        Include(AButtonSet, bkNext);
        Exclude(AButtonSet, bkFinish);
      end;
    end;
    ATop := ClientRect.Bottom - FButtonBarHeight + ciButtonPlacement + 2;
    { YW - Position left side buttons }
    ALeft := ClientRect.Left + ciButtonPlacement;
    LocateButton(bkHelp, ciButtonPlacement + 2);
    LocateButton(bkStart, 1);
    LocateButton(bkLast, 0);
    { YW - Position right side buttons }
    ALeft := ClientRect.Right - ciButtonPlacement;
    if [bkNext, bkFinish] * AButtonSet = [bkNext, bkFinish] then
    begin
      LocateButton(bkCancel, -1);
      LocateButton(bkFinish, -ciButtonPlacement - 2);
    end
    else
    begin
      LocateButton(bkCancel, -ciButtonPlacement - 2);
      LocateButton(bkFinish, -1);
    end;
    LocateButton(bkNext, -1);
    LocateButton(bkBack, 0);
  end
  else // Hide all buttons
  begin
    for AButtonKind := Low(TKWizardButtonKind) to High(TKWizardButtonKind) do
    begin
      with FNavigateButtons[AButtonKind] do
      begin
        FControl.SetBounds(0, 0, FControl.Width, 0); // YW - Must keep the width
      end;
    end;
  end;
end;

procedure TKWizard.GetChildren(Proc: TGetChildProc; Root: TComponent);
var
  i: Integer;
  Control: TControl;
begin
  { YW - Force the wizard to load its pages in page order. }
  for i := 0 to FPages.Count - 1 do
  begin
    Proc(TComponent(FPages[i]));
  end;
  { YW - Load other controls, otherwise, those controls won't show up in
     the wizard. }
  for i := 0 to ControlCount - 1 do
  begin
    Control := Controls[i];
    { YW - Because all the pages are already loaded, so here we do NOT need to
       load them again, otherwise it will cause 'duplicate component nam'
       error. }
    if not (Control is TKWizardCustomPage) and (Control.Owner = Root) then
    begin
      Proc(Control);
    end;
  end;
end;

procedure TKWizard.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited;
  if (Operation = opRemove) and (AComponent = FHeaderImages) then
  begin
    SetHeaderImages(nil);
  end;
end;

procedure TKWizard.ImageListChange;
begin
  if HandleAllocated and (Sender = FHeaderImages) and Assigned(FActivePage) then
  begin
    FActivePage.Invalidate;
  end;
end;

procedure TKWizard.ShowControl(AControl: TControl);
begin
  if (AControl is TKWizardCustomPage) and
     (TKWizardCustomPage(AControl).Wizard = Self) then
    SetActivePage(TKWizardCustomPage(AControl));
  inherited ShowControl(AControl);
end;

procedure TKWizard.Resize;
begin
  RepositionButtons;
  inherited;
end;

function TKWizard.IsForward(const FromPage, ToPage: TKWizardCustomPage): Boolean;
begin
  if Assigned(FromPage) and Assigned(ToPage) and
     (FromPage.Wizard <> ToPage.Wizard) then
    raise EKWizard.Create(rsInvalidWizardPage);
  Result := not Assigned(FromPage) or (Assigned(ToPage) and
      (FromPage.PageIndex < ToPage.PageIndex));
end;

end.
